/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("dm.common.app.ui.internal.TabManager");

(function() {
	dojo.declare(
			"dm.common.app.ui.internal.TabManager",
			null, 
		{
			constructor: function() {
				this._tabDescriptors = [];
			},
			
			destroy: function() {
				dojo.forEach(this._tabDescriptors, function(tab) {
					if(tab.connectHandle) {
						dojo.disconnect(tab.connectHandle);
					}
				});
			},
			
			registerTab: function(tab, content, style) {
				var descriptor= { tab: tab, content: content, styleName: style};
				descriptor.oldDisplay= content.style.display;
				descriptor.connectHandle = dojo.connect(tab, "onclick", this, "_handleClick"); // nonwidget- must be dojo connect
				this._tabDescriptors.push(descriptor);
			},
			
			showTab: function(tabNode) {
				var tabDescriptors= this._tabDescriptors;
				var td = undefined;
				
				for (var i= 0; i < tabDescriptors.length; i++) {
					td = tabDescriptors[i];
					if (td.tab === tabNode) {
						this._activate(td);
					} else {
						this._deactivate(td);
					}
				}
			},
			
			_handleClick: function(event) {
				dojo.stopEvent(event);
				this.showTab(event.currentTarget);
			},
			
			_activate: function(tabDescriptor) {
				dojo.addClass(tabDescriptor.tab, tabDescriptor.styleName);
				tabDescriptor.content.style.display= tabDescriptor.oldDisplay;
			},
			
			_deactivate: function(tabDescriptor) {
				dojo.removeClass(tabDescriptor.tab, tabDescriptor.styleName);
				tabDescriptor.content.style.display= "none";
			}
			
		});

})();