 /*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.analysis.app.ui.internal.impactanalysis.IAColorTable");


// This is the primary color. Copied from:
// https://jazz.net/jazz04/service/com.ibm.team.workitem.common.internal.rest.IAttachmentRestService/itemName/com.ibm.team.workitem.Attachment/9683
		
var elementBorderColor =['#c5c5c5' , 
                         '#b6def3' ,
						 '#ffc68c' ,
						 '#f8c7c7' ,
						 '#ace6b6' ,
						 '#d2c2f3' ,
						 '#d4d483' ,
						 '#a6a6a6' ,
						 '#ccb88f',
						 '#aec2cc'];

// These values were calculated by picking off of the sample image
// in the above diagram with MS Paint.			 				
var elementHeaderColor =['#EDEDED' ,
						  '#E5F6FF' ,
						  '#FFEEDC',
						  '#FFE5E5' ,
						  '#E2FAE6' ,
						  '#F0EAFE' ,
						  '#F7F7D5' ,
						  '#E4E4E4' ,
						  '#F4EBD9' ,
						  '#E5EEF2'];					

var elementColors =['#f8f8f8',
                    '#f6fbf3',
					'#fff8f1',
					'#fef6f6',
					'#f5fcf6',
					'#faf8fe',
					'#fafaf0',
					'#f4f4f4',
					'#f9f6f1',
					'#f5f8f9'];						 
 

var linksColors ={"intra" : "#999999",
					"inter" : "green",
				   "crossDomain" :"blue"
				   };

var linksBorderColors ={"intra" : "#999999",
						"inter" : "green",
				        "crossDomain" :"blue"
				       };


dm.analysis.app.ui.internal.impactanalysis.IAColorTable = {
	
	getElementColor:  function (colorId)
	{
//		return elementColors[colorId];
		return elementHeaderColor[colorId];
	},
	
	
	getLinkColor: function (linkType)
	{
		return linksColors[linkType];
	},
	
	getElementBorderColor:  function (colorId)
	{
		return elementBorderColor[colorId];
	},
	
	getFocalBorderColor: function(){
		return "#8FBC8F"; 
	},
	
	getFocalBackgroundColor: function(){
		return "#EDF8EB";
	},
	
	getBoundTypeBackgroundColor: function(){
		return "#FFF3F3";
	},

	getBoundTypeBorderColor: function(){
		return "#E9967A";
	},
	getFocalBorderWidth: function(){
		return 3;
	},
	
	getLinkBorderColor: function (linkType)
	{
		return linksBorderColors[linkType];
	},
	
	getOnClickColor : function ()
	{
		return "#008ABF";
	},
	
	getOnHoverColor : function ()
	{
		return "#FCB813";
	}
	
};

}());
