/**
 * @author nirm
 * will control the following 
 */

 /*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisController");

dojo.require("dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil");
var AnalysisUtil = dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil;

dojo.declare("dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisController", null, {
	
	// private properties
	_page: null,
	
	_defaultUrl: null,
	
	constructor: function(page) {
		this._page = page;
	},
	
	welcome: function() {
		this._page.showWelcome();
		this._defaultUrl = window.location.href;
	},
	
	_default: function(args) {
		if (this._defaultUrl) {
			setTimeout(dojo.hitch(this, function() {
				window.location.href = this._defaultUrl;
			}), 0);
			return;
		}
		this.welcome(args);
	},
	impactanalysis__default: function(args) {
		this._default(args);
	},
	
	
//// IA Diagrams ////

	impactAnalysis: function(args) {
		
		if (args.resourceUri )
		{
			this._defaultUrl = window.location.href;	
			this._page.showImpactAnalysis(args.resourceUri, this._getEditorArgs(args));
		}
		else if (args.targetUri ){
			this.targetUri = args.targetUri;
			var newIA = new dm.analysis.app.ui.internal.impactanalysis.models.ImpactAnalysis();
			newIA.targetResourceUri = args.targetUri;
			var deferred = dm.analysis.app.ui.internal.impactanalysis.models.RHImpactClient.createImpactAnalysis(newIA);
			deferred.addCallback(this, function(ia) {
					this._defaultUrl = AnalysisUtil.getAnalysisUri(ia.uri);
					window.location.href = AnalysisUtil.getAnalysisUri(ia.uri);
			});
		}
		else {
			throw ("Impact analysis - Illegal URL , resource URI or targetUri not provided as URL parameters");
		}
	},
	
	impactanalysis_impactAnalysis: function(args) {
		this.impactAnalysis(args);
	},
	
		
	allImpacts : function(args) {
		this._defaultUrl = window.location.href;
		this._page.showAllImpacts(this._getEditorArgs(args));
	},
	
	impactanalysis_allImpacts : function(args) {
		this.allImpacts(args);
	},
	
	impactsForGroup: function(args)
	{
		this._defaultUrl = window.location.href;
		this._page.showImpactsForGroup(this._getEditorArgs(args));
	},
	
//// IA Configs ////

	iaConfig: function(args) {
		
		if (args.resourceUri )
		{
			this._defaultUrl = window.location.href;	
			this._page.showIAConfig(args.resourceUri, this._getEditorArgs(args));
		}
		
		else {
			throw ("Impact analysis - Illegal URL , resource URI or targetUri not provided as URL parameters");
		}
	},
	
	impactanalysis_iaConfig : function(args) {
		this.iaConfig(args);
	},

	allIAConfigs: function(args)
	{
		this._defaultUrl = window.location.href;
		this._page.showAllIAConfigs(this._getEditorArgs(args));
	},
	
	impactanalysis_allIAConfigs : function(args) {
		this.allIAConfigs(args);
	},
	

//// IA Profiles ////

	iaProfile: function(args) {
		
		if (args.resourceUri )
		{
			this._defaultUrl = window.location.href;	
			this._page.showIAProfile(args.resourceUri, this._getEditorArgs(args));
		}
		
		else {
			throw ("Impact Analysis - Illegal URL , resource URI or targetUri not provided as URL parameters");
		}
	},

	impactanalysis_iaProfile: function(args){
		this.iaProfile(args);
	},

	allIAProfiles: function(args)
	{
		this._defaultUrl = window.location.href;
		this._page.showAllIAProfiles(this._getEditorArgs(args));
	},

	impactanalysis_allIAProfiles : function(args) {
		this.allIAProfiles(args);
	},
	
	_getEditorArgs: function(args) {
		var rest = dojo.clone(args);
		delete rest.action;
		delete rest.id;
		return rest;
	}
	
	
});

})();
