/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisLegend");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.gfx");
dojo.require("dijit.Tooltip");

dojo.declare("dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisLegend", [dijit._Widget, dijit._Templated], {
	
	templateString: '<div class="rmpw-legend-outline">'+ 
	                 '<div dojoAttachPoint="containerNode" style="width:200px;height:50px;"></div>' + 
					 '</div>',

	keys: null,
	
	postCreate: function(){
		this.inherited( arguments );
		
		this.keys = [];
		
		this.surface = dojox.gfx.createSurface(this.containerNode, 200, 50);
		
		var test = [ { color:'blue', description: 'John' }, 
					{ color:'red', description: 'Paul' },
					{ colors: [{offset: 0, color: [251,238,238, 1]}, {offset: 1, color: [229,127,128, 1]}], description: 'George' },
					{ color:'yellow', description: 'Ringo' }];
	},
	
	fill: function( item, data ){
		
		if( data.color ){
			item.setFill( data.color );
		}else{
			if( !dojo.isIE ){
				item.setFill( {
					type: "linear", x1: 0, y1: 0, x2: 0, y2: 25 ,
					colors: data.colors
				});
			}
		}
		
		if( data.line ){
			item.setStroke( data.line );
		}
	},
	
	
	/* setElements takes and array of entries:
	 * 
	 * [ { color:'blue', description: 'John' }, 
	 *   { color:'red', description: 'Paul' },
	 *   { colors: [{offset: 0, color: [251,238,238, 1]}, {offset: 1, color: [229,127,128, 1]}], description: 'George' },
	 *   { color:'yellow', description: 'Ringo' } ]
	 * 
	 */
	
	setElements: function( elements ){
		
		var gap = 15;
		
		var rows = elements.length / 2;
		
		var totalHeight = 5 + rows * gap;
		
		this.domNode.style.height = totalHeight + 'px';
		
		var font = {family: "sans-serif", size: "9px"};

	    var measurementHeightError = 4;		
		
		var x = 5;
		var dx = 105;
		
		for( var e=0; e<elements.length;e++ ){
			var row = Math.floor(e/2);	
			var y = 5 + ( row * gap );
			this.keys[e] = this.surface.createRect( {x: x, y: y, height:10, width:10 } );
			this.fill( this.keys[e], elements[e] );		
			
			/* Floating some clear divs about the vector squares to 
			 * latch some tooltips onto. Might be able to simplify this 
			 * all with some css3.
			 */
			
			var t = document.createElement("div");
			
			var dy = totalHeight - ( gap + ( row * gap ) );
			
			t.style.width = '90px';
			t.style.height = '10px';
			t.style.position = 'absolute';		
			t.style.bottom = dy + 'px';
			t.style.right =  dx + 'px';
			
			t.title = elements[e].description;
			
			/* For testing position of divs 
			
			t.style.background = 'silver';
			t.innerHTML = e; */
									
			this.domNode.appendChild(t);
			
			this.surface.createText( {text: elements[e].label, x: x + 13,
				y: y + 8 }).setFill("black").setFont(font);	
			
			if( x === 5 ){ x = 100; dx = 10; }else{ x = 5; dx = 105; }
		}
	}
});

})();