/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisPanelsContainer");

dojo.require("dijit._Widget");


dojo.require("rmps.app.ui.internal.editors.BaseEditor");
dojo.require("rmps.ui.editor.EditorUtil");
dojo.require("rmps.ui.Accordion");
dojo.require("dojo.string");
dojo.require("dojo.i18n");
dojo.require('jazz.app.ua.PageHoverHelp');
dojo.require("dm.analysis.app.ui.internal.impactanalysis.panels.TreeNavigationPanel");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.panels.AddElementListPanel");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.panels.RemoveElementListPanel");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.panels.ArtifactFilterListPanel");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.panels.CommentPanel");

dojo.requireLocalization("dm.analysis.app.ui.internal.impactanalysis", "ImpactAnalysisMessages"); 
var messages = dojo.i18n.getLocalization("dm.analysis.app.ui.internal.impactanalysis", "ImpactAnalysisMessages");

var UA_KEY_NAVTREE = "com.ibm.xtools.impactanalysis.web.app.section_NavTree001";
var UA_KEY_ADDED_ARTIFACTS = "com.ibm.xtools.impactanalysis.web.app.section_AddArtis001";
var UA_KEY_HIDDEN_ARTIFACTS = "com.ibm.xtools.impactanalysis.web.app.section_Hide_Artis001";
var UA_KEY_HIDDEN_TYPES = "com.ibm.xtools.impactanalysis.web.app.section_Hide_Types001";
var UA_KEY_COMMENTS = "com.ibm.xtools.impactanalysis.web.app.section_Comments001";

dojo.declare("dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisPanelsContainer", [dijit._Widget, dijit._Templated], {
	
	messages: messages,
	widgetsInTemplate: true,
	templateString:
				'<div>' +
					'<div class="item" dojoAttachPoint="panelsContainer">' +
				'</div>' +
			'</div>',
			
	// init properties
	editor: null,

	//panels
	treeNavPanel: null,

	//widgets to destroy
	_pageHoverHelps: [],
	
	postCreate: function() {
		this.aContainer = new rmps.ui.Accordion();

		this.treeNavPanel = new dm.analysis.app.ui.internal.impactanalysis.panels.TreeNavigationPanel({editor: this.editor});
		this.treeNavPanel.containerNode = this.treeNavPanel.domNode;
		this.treeNavPanel.title = messages.panelTreeNavTitle;
		this.aContainer.addChild(this.treeNavPanel);

		this.addedArtifactsPanel = new dm.analysis.app.ui.internal.impactanalysis.panels.AddElementListPanel({
			editor: this.editor, 
			listChangeCallback: dojo.hitch(this, this._redrawDiagram)
		});
		this.addedArtifactsPanel.containerNode = this.addedArtifactsPanel.domNode;
		this.addedArtifactsPanel.title =  messages.panelAddedArtifactsTitle;
		this.aContainer.addChild(this.addedArtifactsPanel);

		this.hiddenArtifactsPanel = new dm.analysis.app.ui.internal.impactanalysis.panels.RemoveElementListPanel({editor: this.editor});
		this.hiddenArtifactsPanel.containerNode = this.hiddenArtifactsPanel.domNode;
		this.hiddenArtifactsPanel.title = messages.panelHiddenArtifactsTitle;
		this.aContainer.addChild(this.hiddenArtifactsPanel);

		this.hiddenArtifactTypesPanel = new dm.analysis.app.ui.internal.impactanalysis.panels.ArtifactFilterListPanel({editor: this.editor});
		this.hiddenArtifactTypesPanel.containerNode = this.hiddenArtifactTypesPanel.domNode;
		this.hiddenArtifactTypesPanel.title = messages.panelHiddenArtifactTypesTitle;
		this.aContainer.addChild(this.hiddenArtifactTypesPanel);

		this.commentPanel = new dm.analysis.app.ui.internal.impactanalysis.panels.CommentPanel({editor: this.editor});
		this.commentPanel.containerNode = this.commentPanel.domNode;
		this.commentPanel.title = messages.panelCommentTitle;
		this.aContainer.addChild(this.commentPanel);

		this.panelsContainer.appendChild(this.aContainer.domNode);
	},

	startup: function(){
		this.inherited(arguments);
		this.aContainer.startup();
		this.aContainer.layout();

		this._addCSHInPanelTitles();
	},
	
	resize: function(size)
	{
		this.aContainer.resize(size);
	},
	
	//NOTE: only call this AFTER accordion container startup()
	//      Since it instantiates the panel titles (aka _buttonWidget), so we can now mess with the title nodes directly
	_addCSHInPanelTitles: function(){
		var csh_navTree = this._createCSHWidget(UA_KEY_NAVTREE);
		csh_navTree.style.margin = "0 0 0 3px";
		csh_navTree.style.verticalAlign = "top";
		this.treeNavPanel._buttonWidget.titleTextNode.appendChild(csh_navTree);

		var csh_addedArtifacts = this._createCSHWidget(UA_KEY_ADDED_ARTIFACTS);
		csh_addedArtifacts.style.margin = "0 0 0 3px";
		csh_addedArtifacts.style.verticalAlign = "top";
		this.addedArtifactsPanel._buttonWidget.titleTextNode.appendChild(csh_addedArtifacts);

		var csh_hiddenArtifacts = this._createCSHWidget(UA_KEY_HIDDEN_ARTIFACTS);
		csh_hiddenArtifacts.style.margin = "0 0 0 3px";
		csh_hiddenArtifacts.style.verticalAlign = "top";
		this.hiddenArtifactsPanel._buttonWidget.titleTextNode.appendChild(csh_hiddenArtifacts);

		var csh_hiddenArtifactTypes = this._createCSHWidget(UA_KEY_HIDDEN_TYPES);
		csh_hiddenArtifactTypes.style.margin = "0 0 0 3px";
		csh_hiddenArtifactTypes.style.verticalAlign = "top";
		this.hiddenArtifactTypesPanel._buttonWidget.titleTextNode.appendChild(csh_hiddenArtifactTypes);

		var csh_comments = this._createCSHWidget(UA_KEY_COMMENTS);
		csh_comments.style.margin = "0 0 0 3px";
		csh_comments.style.verticalAlign = "top";
		this.commentPanel._buttonWidget.titleTextNode.appendChild(csh_comments);
	},

	getTreeNav : function ()
	{
		return this.treeNavPanel.getTreeNav();
	},

	_createCSHWidget: function(uaKey) {
		var params = {};
		params.uaKey = uaKey;
		var pageHelp = new jazz.app.ua.PageHoverHelp(params);
		this._pageHoverHelps.push(pageHelp);
		return  pageHelp.domNode;
	},

	//Called by anything that wants to redraw the diagram
	_redrawDiagram: function(){
		this.editor._apply();
	},

	/* HIDDEN ARTIFACTS */
	addRemovedElement: function(uri, name, type)
	{
		this.hiddenArtifactsPanel.addElement(uri, name, type, false);
	},
	getRemovedElementName: function(removedElement)
	{
		return this.hiddenArtifactsPanel.getElementName(removedElement);
	},

	/* HIDDEN ARTIFACT TYPES */
	addArtifactQuickFilter: function(type, typeName)
	{
		this.hiddenArtifactTypesPanel.addElement(type, typeName, type, false);
	},

	/* COMMENT */
	getCommentText: function(){
		return this.commentPanel.getCommentText();
	},

	destroy: function(){
		dojo.forEach(this._pageHoverHelps, function(hoverHelp){
			hoverHelp.destroyRecursive();
		});

		this.inherited(arguments);
	}
	
});
})();
