/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisesForGroupEditor");

dojo.require("dijit._Widget");
dojo.require("dojo.string");
dojo.require("dojo.i18n");
dojo.require("rmps.app.ui.internal.editors.BaseEditor");
dojo.require("rmps.ui.Table");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.models.RHImpactClient");
dojo.require("dm.common.app.ui.internal.rhlink.RHLinkClient");
dojo.require("dm.common.app.ui.internal.rhlink.LocateElementDialog");
dojo.provide("dm.analysis.app.ui.internal.impactanalysis.models.ImpactAnalysis.RHImpactClient");
dojo.require("rmps.app.ui.internal.editors.views.link.LinkClient");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.models.ImpactAnalysis");
dojo.require("dm.common.app.ui.internal.rhlink.IAInfoClient");
dojo.require("rmps.app.ui.internal.editors.views.link.Link");
dojo.require("jazz.app.context");
var DEFUALT_PREDICAT = "http://jazz.net/ns/dm/linktypes#internal";

var RHLinkClient = dm.common.app.ui.internal.rhlink.RHLinkClient;
var LinkClient = rmps.app.ui.internal.editors.views.link.LinkClient;

dojo.declare("dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisesForGroupEditor", rmps.app.ui.internal.editors.BaseEditor, {
	
	isRefreshable: false,
	isReadOnly: true,	
	_diagramWidget: null,
	_content:null,
	editorInput:null,
	resourceInfo:null,
	resourceInfoHeader:null,
	newIA:null,
	projectId:null,
	
	constructor: function (args) {
		this.editorInput= args.editorInput;
	},
	
	postCreate: function() {
		
		this.projectId = jazz.app.context.get().itemId;
		this.inherited(arguments);
		this.resourceInfoHeader = dojo.doc.createElement("span");
		this._headerContent.appendChild(this.resourceInfoHeader);
		
		
	},
	addButtons: function(toolbar) {		
		toolbar.addWidget(new rmps.ui.SimpleButton({
				label: "Select Group",
				onClick: dojo.hitch(this, this.onSelectClick)
			}));
		toolbar.addWidget(new rmps.ui.SimpleButton({
				label: "New",
				onClick: dojo.hitch(this, this.onNewClick)
			}));
		toolbar.addButton(this, this.onRefreshClick, {
			label: "Refresh",
			imgSrc: dojo.moduleUrl("dm.analysis.app", "graphics/icons/refresh.gif")
		});
		
	},
	
	createContentWidget: function() {		
		//project ID
		//get URI
		var defaultUrl = dojo.hash();
		//get the parameters from the URI
		var uriObj = dojo.queryToObject(defaultUrl);
		//get source data XHR call
		var resourceUri = uriObj.resourceUri;
		this.createRelation = uriObj.create; 
		this.resourceInfo = {};
		this.resourceInfo.uri = resourceUri;
		this._content = new dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisesForGroupEditor._Content({editor: this});
		//handleElement: function(resourceUri ,resourceName , resourceType , resourceTool , projectId) {
		//check if element exist
		if (this.resourceInfo.uri != null)
		{
			//if there is a Uri than try to check if the resource exist , if exist then store it
			var getTargetLDDeferred = dm.common.app.ui.internal.rhlink.RHLinkClient.handleElement(uriObj.resourceUri , 
			                              												   uriObj.resourceName,
																						   uriObj.resourceType,
																						   uriObj.toolName,
																						   uriObj.pageUri,
																						   this.projectId);
			getTargetLDDeferred.addCallback(this,  function(info) {
					this.setSourceInfo(this.resourceInfo.uri);	
				});	
		}
		else
		{
			if (this.resourceInfo.uri == null)
			{
			 	this.onSelectClick();
			}
			else
			{
				this.setSourceInfo(this.resourceInfo.uri);	
			}
			
			
		}
		
		return this._content;
	},
	
	activate: function() {
		// until editing is supported, mark as dirty
	},
	onSelectClick: function(){
		var dialog = new dm.common.app.ui.internal.rhlink.LocateElementDialog(this, this.resourceInfo.uri );
	},
	
	onRefreshClick: function() {
		this._content.load();
	},
	
	//TODO check
	onNewClick: function() {
		//start by creating a new impact analysis element
		this.newIA = new dm.analysis.app.ui.internal.impactanalysis.models.ImpactAnalysis();
		var deferred = dm.analysis.app.ui.internal.impactanalysis.models.RHImpactClient.createImpactAnalysis(this.newIA);
    	deferred.addCallback(this, function(ia) {
			this.newIA = ia;
			//then create a link to this entity
			var newLink = new rmps.app.ui.internal.editors.views.link.Link();
			newLink.subject = this.resourceInfo.uri;
			newLink.value = ia.uri;
			
			newLink.predicate = DEFUALT_PREDICAT;
			var deferred = LinkClient.createLink(newLink);
	    		deferred.addCallback(this, function(link) {
				this._content.load();
				window.location.href = AnalysisUtil.getAnalysisUri(this.newIA.uri);
			});
		});
		
		//window.location.href = "#action=dm.app.impactanalysis.impactAnalysis&id=dm.app.impactanalysis" ;
		//window.location.reload();
	},
	
	setSourceInfo: function(sourceURI) {
		alert('ImpactAnalysisesForGroupEditor.setSourceInfo() update???');
		//create sourceDesc:
		var deferred = dm.common.app.ui.internal.rhlink.IAInfoClient.getInfo(sourceURI);
    	deferred.addCallback(this, function(infos) {
			this.resourceInfoHeader.innerHTML = " " + infos[0].shortName ;
			this._content.load();
		});
				
	},
	updateAfterLocate: function (sourceURI)
	{
		this.resourceInfo.uri = sourceURI;
		this.setSourceInfo(sourceURI);
	}
});

dojo.declare("dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisesForGroupEditor._Content", [dijit._Widget, dijit._Templated], {
	
	messages: null, 
	
	widgetsInTemplate: true,
	templateString: '<div>' +
				'<div dojoAttachPoint="mainDiv">' +
				'</div>' +					
			'</div>',
	// init properties
	editor: null,
	_headers:null,
	_table:null,
	postCreate: function() {
		this._headers = this.createTableHeaders();
		this._table = new rmps.ui.Table();
	},
	
	createTableHeader: function(id, args, label) {
		var header = {
				isOrderable: false
			};
		dojo.mixin(header, args);
		header.id = id;
		header.label = label;
		return header;
	},
	
	createTableHeaders: function() {
		var headers = [
			this.createTableHeader("name", {filterParticipant: true, isOrderable: true} , "Name"),
			this.createTableHeader("element", {filterParticipant: true} , "Target Element"),
			this.createTableHeader("lastExecution", { isOrderable: true, defaultAscending: false} , "Last Execution"),
			this.createTableHeader("result", {filterParticipant: true, isOrderable: false} , "Result"),
			this.createTableHeader("actions", {}, "Actions")
			
		];
		return headers;
	},
	
	load: function()
	{
		var deferred = dm.analysis.app.ui.internal.impactanalysis.models.RHImpactClient.getAllImpacted(this.editor.projectId , this.editor.resourceInfo.uri);
    	deferred.addCallback(this, function(result) {
			var tableData =[];
			dojo.forEach(result.ImpactList, function(entry) 
			{
				var resourceUri = entry.URI;
				var presentationUri = "#action=dm.app.impactanalysis.impactAnalysis&id=dm.app.impactanalysis&resourceUri=" + entry.URI;
				
				var row = {
					link: presentationUri,
					resourceUri: resourceUri,
					columns: []
				};
				
				dojo.forEach(this._headers, function(header) {
					var column = this.createColumnObject(entry, header.id, resourceUri, presentationUri);
					row.columns.push(column);
				}, this);
				tableData.push(row);
			
			}, this);
			this._table.setTableData(this._headers, tableData);
			var seconderyOrder = [];
			seconderyOrder.push({id:"name" , isAscending: true});
			this._table.update(false,null,50,result.ImpactList.length,300,"lastExecution" , false , seconderyOrder);
			this.mainDiv.appendChild(this._table.domNode);
		});	
	},
	
	createColumnObject: function(rowObj, columnId, resourceUri, presentationUri) {
		var result = {};
		if (columnId == "name") {
			result.data = rowObj.name;
			result.link = true;
		} else if (columnId == "element") {
			result.data = rowObj.selectedElementName; 
			
		} else if (columnId == "lastExecution") {
			result.data = rowObj.lastExe;
			result.style = { color: "#808080" };
			
		} else if (columnId == "result") {
			result.data = rowObj.resultCount; 
		} else if (columnId == "actions") {
			
			result.className = "actions";
			//result.data = "TBD";
			// prevent row click navigation
		//		result.init = dojo.hitch(this, function(rowConfig, tableRow, rowIdx, columnConfig, cell, colIdx) {
		//		var toolbar = new jazz.ui.SimpleToolbar();
		//		this.createRowActions(toolbar, rowObj, resourceUri, presentationUri);
		//		toolbar.domNode.style.width = ((toolbar.items.length * 26) + 1) + "px";
		// 		use the SimpleToolbar to connect so that disconnect is called on destroy
		//		toolbar.connect(cell, "onmousedown", dojo.hitch(dojo, dojo.stopEvent));
		//		cell.appendChild(toolbar.domNode);
		//	});
			
		}	
		return result;
	},
	createRowActions: function(toolbar, rowObj, resourceUri, presentationUri) {
		this.createDeleteAction(toolbar, rowObj, resourceUri, presentationUri);
	},
	
	createDeleteAction: function(toolbar, rowObj, resourceUri, presentationUri){
		// explore
		var detele = toolbar.addButton(this, function(e) {
				alert("delete");
			}, {
			label: "Delete",
			imgSrc: dojo.moduleUrl("dm.analysis.app", "graphics/icons/remove.gif")
		});
	},
	reset: function()
	{
		
	}
	
});
})();
