/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.analysis.app.ui.internal.impactanalysis.UnlimitedNumberSpinner");

dojo.require("dijit._Widget");
dojo.require("dijit.form.NumberSpinner");
dojo.require("dijit.form.CheckBox");

dojo.requireLocalization("dm.analysis.app.ui.internal.impactanalysis", "ImpactComentMessages"); 
var messages = dojo.i18n.getLocalization("dm.analysis.app.ui.internal.impactanalysis", "ImpactComentMessages");

dojo.declare("dm.analysis.app.ui.internal.impactanalysis.UnlimitedNumberSpinner", [dijit._Widget, dijit._Templated], {
	
	widgetsInTemplate: true,
	val:null,
	templateString: '<div>' +
						'<input '+
							'dojoType="dijit.form.NumberSpinner"  smallDelta="1" '+
							'constraints="{min:0,max:300,places:0}" dojoAttachPoint="numberSpinner"'+
							'intermediateChanges="true" style="width: 100px" />'+
							'&nbsp;&nbsp;Unlimited:&nbsp;&nbsp;'+
							'<input type="checkbox" dojoAttachPoint="unlimitCheck" dojoType="dijit.form.CheckBox">'+
					'</div>',
	
	
	postCreate: function() {
		dojo.connect(this.unlimitCheck,"onChange",dojo.hitch(this, this.handleUnlimtedChange));
		dojo.connect(this.numberSpinner,"onChange", dojo.hitch(this, this.handleSpinnerChange));
	},
	
	handleSpinnerChange : function()
	{
		this.val = this.numberSpinner.get('value'); 
		if (isNaN(this.val))
		{
			this.val = -1;
		}
		this.onchange();
	},
	
	handleUnlimtedChange:function()
	{
		
		if (this.unlimitCheck.get('value') === "on")
		{
			this.numberSpinner.set('value', null);
			this.numberSpinner.set('disabled', true); 
			
		}
		else{
			if (this.val === -1)
			{
				this.val = 0;
				this.numberSpinner.set('value', "0");
				this.numberSpinner.set('disabled', false); 
			}
		}
		this.onchange();
		
	},
	
	setValue: function(v) {
		this.val = v;
		if (this.val === -1)
		{
			this.unlimitCheck.set('checked', true);
		}
		else
		{
			this.numberSpinner.set('value', this.val);
			this.numberSpinner.set('disabled', false);
			this.unlimitCheck.set('checked', false);
		}
	},
	
	setDisabled: function(disabled) {
		this.numberSpinner.set('disabled', disabled);
		this.unlimitCheck.set('disabled', disabled);
	},
	
	getValue: function() {
		return this.val;
	},
	
	onchange:function() {
		
	},
	
	
	
	destroy: function() {
		this.inherited(arguments);
	}
	
});

})();