/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| /com.ibm.xtools.rh.web.impact.app                                      |
 *|                                                                        |
 *| Copyright IBM Corporation 2011.  All Rights Reserved.                  |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */

(function() {
dojo.provide("dm.analysis.app.ui.internal.impactanalysis.application.AnalysisPageInitializer");

/** Initialize the Analysis welcome page by adding the Impact Analysis actions for
 *  browsing and creating impact analyses and impact analysis configurations.
 *  
 *  @author Paul Elder
 */

dojo.require("dm.analysis.app.ui.internal.impactanalysis.application.ImpactAnalysisController");
dojo.require("dm.app.analysis.ui.internal.application.AnalysisActions");
dojo.require("dm.app.analysis.ui.internal.application.AnalysisPage");
dojo.require('dm.analysis.app.ui.internal.impactanalysis.AllImpactAnalysisesEditor');
dojo.require('dm.analysis.app.ui.internal.impactanalysis.AllImpactAnalysisesInput');
dojo.require('dm.analysis.app.ui.internal.impactanalysis.config.AllIAConfigsEditor');
dojo.require('dm.analysis.app.ui.internal.impactanalysis.config.AllIAConfigsInput');
dojo.require('dm.analysis.app.ui.internal.impactanalysis.config.IAConfigEditor');
dojo.require('dm.analysis.app.ui.internal.impactanalysis.config.IAConfigInput');
dojo.require('dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisEditor');
dojo.require('dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisInput');
dojo.require('dm.analysis.app.ui.internal.impactanalysis.profile.AllIAProfilesEditor');
dojo.require('dm.analysis.app.ui.internal.impactanalysis.profile.AllIAProfilesInput');
dojo.require('dm.analysis.app.ui.internal.impactanalysis.profile.IAProfileEditor');
dojo.require('dm.analysis.app.ui.internal.impactanalysis.profile.IAProfileInput');


// dojo.require("dojo.i18n");
// dojo.requireLocalization("dm.analysis.app.ui.internal.impactanalysis.pages", "DMAnalysisMessages"); 
// var messages = dojo.i18n.getLocalization("dm.analysis.app.ui.internal.impactanalysis.pages", "DMAnalysisMessages"); 

var AnalysisActions = dm.app.analysis.ui.internal.application.AnalysisActions;

/** Add the impact analysis content to the analysis welcome page */
dojox.lang.aspect.advise(dm.app.analysis.ui.internal.application.AnalysisPage, "registerExtendedActions", {
	after: function() {
		var page = dojox.lang.aspect.getContext().instance;

		// If this call is for the Impact Analysis section to be initialized
		if (page.getCurrentSection() === AnalysisActions.SECTION_IMPACTANALYSIS) {
			// Create the widget for the Impact Analysis welcome page content
			var controller = new dm.analysis.app.ui.internal.impactanalysis.application.ImpactAnalysisController(page);
			
			page.registerActionEditor("impactanalysis_allImpacts", controller, 
					"dm.analysis.app.ui.internal.impactanalysis.AllImpactAnalysisesEditor",
					"dm.analysis.app.ui.internal.impactanalysis.AllImpactAnalysisesInput");
			
			page.registerActionEditor("impactanalysis_impactAnalysis", controller, 
					"dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisEditor",
					"dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisInput");

			page.registerActionEditor("impactanalysis_allIAConfigs", controller, 
					"dm.analysis.app.ui.internal.impactanalysis.config.AllIAConfigsEditor",
					"dm.analysis.app.ui.internal.impactanalysis.config.AllIAConfigsInput");
			
			page.registerActionEditor("impactanalysis_allIAProfiles", controller, 
					"dm.analysis.app.ui.internal.impactanalysis.profile.AllIAProfilesEditor",
					"dm.analysis.app.ui.internal.impactanalysis.profile.AllIAProfilesInput");
			
			page.registerActionEditor("impactanalysis_iaConfig", controller, 
					"dm.analysis.app.ui.internal.impactanalysis.config.IAConfigEditor",
					"dm.analysis.app.ui.internal.impactanalysis.config.IAConfigInput");

			page.registerActionEditor("impactanalysis_iaProfile", controller, 
					"dm.analysis.app.ui.internal.impactanalysis.profile.IAProfileEditor",
					"dm.analysis.app.ui.internal.impactanalysis.profile.IAProfileInput");

		}
	}
});

})();
