/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.xtools.rh.web.impact.app                                       |
 *|                                                                        |
 *| Copyright IBM Corporation 2011, 2012.  All Rights Reserved.            |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */

(function() {
dojo.provide("dm.analysis.app.ui.internal.impactanalysis.application.ImpactAnalysisWelcome");

/** This widget provides the actual content for the Reports
 *  section of the main Analysis welcome page.
 *  
 *  @author Paul Elder
 */

dojo.require("dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil");

dojo.require("dojo.cache");

dojo.require("dojo.i18n");
dojo.requireLocalization("dm.analysis.app.ui.internal.impactanalysis.application", "ApplicationMessages"); 
var messages = dojo.i18n.getLocalization("dm.analysis.app.ui.internal.impactanalysis.application", "ApplicationMessages"); 


dojo.declare("dm.analysis.app.ui.internal.impactanalysis.application.ImpactAnalysisWelcome", [dijit._Widget, dijit._Templated], {

	"class": "impactAnalysisWelcome",

	messages: messages,
	
	hostPageId: null,
	
	widgetsInTemplate: true,
	
	templateString:
		dojo.cache("dm.analysis.app", "ui/internal/impactanalysis/application/ImpactAnalysisWelcome.template.html"),
		
	constructor: function(args) {
		if(args.hostPageId) {
			this.hostPageId = args.hostPageId;
		}
		this.messages = messages;
	},

	/** Perform the final widget creation steps by calculating the
	 *  actions and inserting them into the appropriate paragraphs in
	 *  the welcome page contents.
	 */
	postCreate: function() {
		this.inherited(arguments);
		
		// Set the hrefs on the title and image anchors for each welcome action.
		var action = dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil.getAllAnalysisUri(this.hostPageId);
		this.viewIADiagsImageAnchor.href = action;
		this.viewIADiagsTitleAnchor.href = action;
		
		action = dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil.getAllConfigAnalysisUri(this.hostPageId);
		this.viewIAFiltersImageAnchor.href = action;
		this.viewIAFiltersTitleAnchor.href = action;
		
		action = dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil.getAllProfileAnalysisUri(this.hostPageId);
		this.viewIAProfilesImageAnchor.href = action;
		this.viewIAProfilesTitleAnchor.href = action;
	}
});

})();
