/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| /com.ibm.xtools.rh.web.impact.app                                      |
 *|                                                                        |
 *| Copyright IBM Corporation 2011.  All Rights Reserved.                  |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */

(function() {
dojo.provide("dm.analysis.app.ui.internal.impactanalysis.application.WelcomeInitializer"); //$NON-NLS-1$

/** Initialize the Analysis welcome page by adding the Impact Analysis actions for
 *  browsing and creating impact analyses and impact analysis configurations.
 *  
 *  @author Paul Elder
 */
dojo.require("dm.app.analysis.ui.internal.application.AnalysisActions"); //$NON-NLS-1$

dojo.require("dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil"); //$NON-NLS-1$
dojo.require("dm.analysis.app.ui.internal.impactanalysis.application.ImpactAnalysisWelcome"); //$NON-NLS-1$
dojo.require('dm.app.analysis.ui.internal.pages.AnalysisWelcome'); //$NON-NLS-1$

// dojo.require("dojo.i18n");
// dojo.requireLocalization("dm.analysis.app.ui.internal.impactanalysis.pages", "DMAnalysisMessages"); 
// var messages = dojo.i18n.getLocalization("dm.analysis.app.ui.internal.impactanalysis.pages", "DMAnalysisMessages"); 

var AnalysisActions = dm.app.analysis.ui.internal.application.AnalysisActions;

/** Add the impact analysis content to the analysis welcome page */
dojox.lang.aspect.advise(dm.app.analysis.ui.internal.pages.AnalysisWelcome, "addExtendedSectionContent", { //$NON-NLS-1$
	after: function() {
		var editor = dojox.lang.aspect.getContext().instance;

		// If this call is for the Impact Analysis section to be initialized
		if (editor.getCurrentSection() === AnalysisActions.SECTION_IMPACTANALYSIS) {
			// Create the widget for the Impact Analysis welcome page content
			var containerNode = editor.getSectionContainer();
			var impactAnalysisWelcome = new dm.analysis.app.ui.internal.impactanalysis.application.ImpactAnalysisWelcome(
					{hostPageId:editor.params.editorInput.getPageId()});
			
			// Connect the content into the Analysis welcome page
			containerNode.appendChild(impactAnalysisWelcome.domNode);
		}
	}
});

})();