/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.analysis.app.ui.internal.impactanalysis.config.CreateSelectionToolDialog");
dojo.require("jazz.ui.Dialog");
dojo.require("dm.common.app.ui.internal.rhlink.AnalysisConfigClient");
dojo.require("jazz.app.context");
dojo.require("jazz.ui.StyledBox");


dojo.requireLocalization("dm.analysis.app.ui.internal.impactanalysis.config", "ImpactAnalysisConfigMessages"); 
var messages = dojo.i18n.getLocalization("dm.analysis.app.ui.internal.impactanalysis.config", "ImpactAnalysisConfigMessages"); 

dojo.declare("dm.analysis.app.ui.internal.impactanalysis.config.CreateSelectionToolDialog", null,  {
	parent:null,
	iaConfig:null,
	projectId: null,
	
	text: null,
	width: null,
	
	linkDirection:null,
	toolType:null,
	addToolButton:null,
	
	createTable: null,
	
	constructor: function(parent , iaConfig) {
		this.parent = parent;
		this.iaConfig = iaConfig;
		this.projectId =  jazz.app.context.get().itemId;
		this.createDialog(this.text,this.width);
	},
		
	createDialog: function(text, width){
		
		var createTable = dojo.doc.createElement("table");
		//tool types
		this.toolType = dojo.doc.createElement("select");
		this.createRelationRow(createTable,messages.iaEditorSelectionToolDialogTool , this.toolType);
		//link Direction	
		this.linkDirection = dojo.doc.createElement("select");
		var optionChild = dojo.doc.createElement("option");
		optionChild.innerHTML = this.parent.LINK_DIRECTION.TRUE;
		optionChild.value="TRUE";
		this.linkDirection.appendChild(optionChild);
		var optionChild1 = dojo.doc.createElement("option");
		optionChild1.innerHTML = this.parent.LINK_DIRECTION.FALSE;
		optionChild1.value="FALSE";
		this.linkDirection.appendChild(optionChild1);				
		this.createRelationRow(createTable,messages.iaEditorSelectionToolDialogDirection , this.linkDirection);
		//add button
		this.addToolButton = dojo.doc.createElement("button");
		this.addToolButton.innerHTML = "Add";
		dojo.connect(this.addToolButton,"onclick",this, function() { this.add(); });
		this.createRelationRow(createTable,null , this.addToolButton);
		// fill tools
		this._getToolsTypesDeferred = dm.common.app.ui.internal.rhlink.AnalysisConfigClient.getToolsTypes(this.projectId);
		this._getToolsTypesDeferred.addCallback(this, function(tools) {
			for(var i = 0 ; i < tools.tools.length ; i++) {
				if (this.checkIfToolExistAlready(tools.tools[i].ToolURI) === false) {
					var optionChild = dojo.doc.createElement("option");
					optionChild.innerHTML = tools.tools[i].ToolType;
					optionChild.value = tools.tools[i].ToolURI;
					this.toolType.appendChild(optionChild);
				}
			}
			this.inprogress(false);
		});
		
		var dialogContent = dojo.doc.createElement("div");
		dialogContent.className =  "rh-app-pages-rh-links";
		dialogContent.appendChild(createTable);
		
		this.createDialog = new jazz.ui.Dialog({
			primaryTitle: messages.iaEditorSelectionToolDialogTitle,
			modal: true,
			trim: jazz.ui.StyledBox.TrimStyles.BLUE_ALPHA_SHADOW,
			center: true,
			closeOnEsc: true,
			headerless: false,
			closable: true,
			width: 700 + "px",
			moveable: true,
			collapsible: false,
			showBackground: false,
			contentNode: dialogContent,
			onClose: parent.closeEdit
		});
		this.inprogress(true);
		this.createDialog.startup();
	},
	
	/*
	 * avoid the case where you will be able to add two tools
	 */
	checkIfToolExistAlready: function (toolUri) {
		for (var i = 0 ; i < this.iaConfig.selectedTools.length; i ++)
		{
			if (toolUri === this.iaConfig.selectedTools[i].tool )
			{
				return true;
			}
		}
		return false;
		
	},
	
	inprogress: function (inprogress)
	{
		if (inprogress === true)
		{
			this.addToolButton.disabled =true;
		}
		else
		{
			this.addToolButton.disabled =false;
		}
	}
	,
	
	createRelationRow: function(table ,name , value)
	{
		var tr = dojo.doc.createElement("tr");
		if (name != null)
		{
			var td1 = dojo.doc.createElement("td");
			td1.innerHTML = name;
			tr.appendChild(td1);
		}
		var td2 = dojo.doc.createElement("td");
		td2.appendChild(value);
		tr.appendChild(td2);
		table.appendChild(tr);
	},
	
	
	add: function() {
		this.parent.updateAfterAddTool( {tool:this.toolType.value , linksDirection:this.linkDirection.value} ,
											 this.toolType.options[this.toolType.selectedIndex].text );
		this.createDialog.close();
		
    }
	
});

})();