/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("dm.analysis.app.ui.internal.impactanalysis.models.ImpactAnalysis");
	
	dojo.require("dojox.data.dom");
	dojo.require('dojo.date.locale');

	dojo.require("rmps.core.resource.Resource");
	dojo.require("rmps.core.user.UserClient");
	dojo.require("jazz.util.html");

	///////////////////////////////////////////
	/* full XML
	<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:rhImpactAnalysis="http://jazz.net/xmlns/rh/impacAnalysis/1.0/" xmlns:dcterms="http://purl.org/dc/terms/">
		<rhImpactAnalysis:ImpactAnalysis rdf:about="https://harbinger:9444/dm/impactanalysis/3b9884ee-c776-4947-a067-95f9d51a848c">
			<rhImpactAnalysis:hasArtifactImpact>
				<rhImpactAnalysis:ImpactArtifact>
					<rhImpactAnalysis:artifactStatus>MAIN</rhImpactAnalysis:artifactStatus>
					<rhImpactAnalysis:artifact rdf:resource="https://harbinger:9444/dm/models/28"></rhImpactAnalysis:artifact>
				</rhImpactAnalysis:ImpactArtifact>
			</rhImpactAnalysis:hasArtifactImpact>
			<rhImpactAnalysis:closeDate></rhImpactAnalysis:closeDate>
			<rhImpactAnalysis:hasGolbalImpactConfig>
				<rhImpactAnalysis:ImpactConfigParam>
					<rhImpactAnalysis:configIsReduced>undefined</rhImpactAnalysis:configIsReduced>
					<rhImpactAnalysis:profileIncluded>false</rhImpactAnalysis:profileIncluded>
					<rhImpactAnalysis:configComment></rhImpactAnalysis:configComment>
					<rhImpactAnalysis:configType rdf:resource="https://harbinger:9444/dm/impactprofile/defaultProfile-_rmIPMukAEeKoxKd-cZDbcA"></rhImpactAnalysis:configType>
				</rhImpactAnalysis:ImpactConfigParam>
			</rhImpactAnalysis:hasGolbalImpactConfig>
			<dcterms:description></dcterms:description>
			<rhImpactAnalysis:impactTimestamp>2013-07-11T17:11:14-07:00</rhImpactAnalysis:impactTimestamp>
			<rhImpactAnalysis:startDate></rhImpactAnalysis:startDate>
			<rhImpactAnalysis:impactName>testw</rhImpactAnalysis:impactName>
			<rhImpactAnalysis:impactDueDate></rhImpactAnalysis:impactDueDate>
			<rhImpactAnalysis:owner></rhImpactAnalysis:owner>
			<rhImpactAnalysis:impactStatus>InProgress</rhImpactAnalysis:impactStatus>
		</rhImpactAnalysis:ImpactAnalysis>
	</rdf:RDF>
	*/
	
	//////////////////////////////////////////
		

	var UserClient = rmps.core.user.UserClient;

	var XMLNS = "http://open-services.net/ns/am#";
	var RH_IA  = "http://jazz.net/xmlns/rh/impacAnalysis/1.0/";
	var	DC    = "http://purl.org/dc/terms/";
	var	RDF   = "http://www.w3.org/1999/02/22-rdf-syntax-ns#";
	var CONTENT_TYPE_IA = "application/rdf+xml";
	
	var IA_QUALIFIER ="rhImpactAnalysis";
	
	//var IAP_NAMESPACE = "http://jazz.net/xmlns/rh/impacAnalysis/1.0/";
	//var IAP_QUALIFIER ="iaProfile";

	var BOOLEAN = "http://www.w3.org/2001/XMLSchema#boolean";
	var INT  = "http://www.w3.org/2001/XMLSchema#int";

	var IA_STATUS = "impactStatus";
	var IA_NAME ="impactName";
	//config
	var IA ="ImpactAnalysis";
	var IA_TYPE ="configType";
	var IA_REDUCE ="configIsReduced";
	var IA_COMMENT = "configComment";
	var IA_PROFILE_INCLUDED = "profileIncluded";
	//excution
	var IA_ARTIFACT ="artifact";
	var IA_ARTIFACT_STATUS ="artifactStatus";
	
	var STATUS_DRAFT = "Draft";
	var STATUS_IN_PROGRESS = "InProgress";
	
	var ARTIFACT_MAIN = "MAIN";
	var ARTIFACT_ADD = "ADD";
	var ARTIFACT_REMOVE = "REMOVE";
	var ARTIFACT_QUICK_FILTER = "ARTIFACT_QUICK_FILTER";
	var ARTIFACT_EXPANSION_SEQUENCE = "ARTIFACT_EXPANSION_SEQUENCE";

	dojo.declare("dm.analysis.app.ui.internal.impactanalysis.models.ImpactAnalysis", rmps.core.resource.Resource, {

	// private properties
	description: '',
	shortName: '',
	eTag: null,

	////
	targetResourceUri: null,
	iAType: null,
	iAReduceResult: null,
	impactStatus: null,
	iAComment: null,
	iAIncludedProfile: null,

	addedElements: null,
	removedElements: null,
	artifactQuickFilters: null,
	expansionSequence: null,
	
	//TBD add/Remove list / comments
	
	constructor: function() {
		this.resultUri = "";
		this.resultLastExe = "";
		this.resultCount = 0;
		this.addedElements = [];
		this.removedElements = [];
		this.artifactQuickFilters = [];
		this.expansionSequence = [];
	},
	
	isReadyToRun: function () {
		// tests whether the Impact Analysis can be run.
		// Insists that targetResourceUri, and iAType are set
		return this.targetResourceUri !== null && this.iAType !== null;
	},
	
	getName: function()
	{
		return this.shortName;
	},
	
	getInprogress: function()
	{
		return this.STATUS_IN_PROGRESS;
	},
	
	getDraft: function()
	{
		return this.STATUS_IN_DRAFT;
	},
	
	
	getContributor: function() {
		var deferred;
		if (this._contributor && this._contributor.uri === this.contributor) {
			deferred = new dojo.Deferred();
			setTimeout(dojo.hitch(this, function() {
				deferred.callback(this._contributor);
			}), 0);
			return deferred;
		}
		deferred = UserClient.getUser(this.contributor);
		deferred.addCallback(dojo.hitch(this, function(user) {
			this._contributor = user;
		}));
		return deferred;
	},

	getCreator: function() {
		var deferred;
		if (this._creator && this._creator.uri === this.creator) {
			deferred = new dojo.Deferred();
			setTimeout(dojo.hitch(this, function() {
				deferred.callback(this._creator);
			}), 0);
			return deferred;
		}
		deferred = UserClient.getUser(this.creator);
		deferred.addCallback(dojo.hitch(this, function(user) {
			this._creator = user;
		}));
		return deferred;
	},
	
	/* POSTed XML ------------------------------------------------
	<rdf:RDF xmlns="http://open-services.net/ns/am#" xmlns:dcterms="http://purl.org/dc/terms/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:rhImpactAnalysis="http://jazz.net/xmlns/rh/impacAnalysis/1.0/">
		<rhImpactAnalysis:ImpactAnalysis rdf:about="https://harbinger:9444/dm/impactanalysis/3b9884ee-c776-4947-a067-95f9d51a848c">
			<rhImpactAnalysis:impactStatus>InProgress</rhImpactAnalysis:impactStatus>
			<rhImpactAnalysis:impactName>testw</rhImpactAnalysis:impactName>
			<dcterms:description></dcterms:description>
			<rhImpactAnalysis:owner></rhImpactAnalysis:owner>
			<rhImpactAnalysis:startDate></rhImpactAnalysis:startDate>
			<rhImpactAnalysis:impactDueDate></rhImpactAnalysis:impactDueDate>
			<rhImpactAnalysis:closeDate></rhImpactAnalysis:closeDate>
			<rhImpactAnalysis:hasGolbalImpactConfig>
				<rhImpactAnalysis:ImpactConfigParam>
					<rhImpactAnalysis:configType rdf:resource="https://harbinger:9444/dm/impactprofile/defaultProfile-_rmIPMukAEeKoxKd-cZDbcA"></rhImpactAnalysis:configType>
					<rhImpactAnalysis:configIsReduced>undefined</rhImpactAnalysis:configIsReduced>
					<rhImpactAnalysis:configComment></rhImpactAnalysis:configComment>
					<rhImpactAnalysis:profileIncluded>true</rhImpactAnalysis:profileIncluded>
					<rhImpactAnalysis:traversal>Downstream</rhImpactAnalysis:traversal>
					<rhImpactAnalysis:downstreamDepth rdf:datatype="http://www.w3.org/2001/XMLSchema#int">2</rhImpactAnalysis:downstreamDepth>
					<rhImpactAnalysis:impactConfig rdf:parseType="Resource">
						<rhImpactAnalysis:profile rdf:resource="https://harbinger:9444/dm/impactconfig/defaultConfig-_rmIPMukAEeKoxKd-cZDbcA"></rhImpactAnalysis:profile>
						<rhImpactAnalysis:enableDeselecting rdf:datatype="http://www.w3.org/2001/XMLSchema#boolean">true</rhImpactAnalysis:enableDeselecting>
					</rhImpactAnalysis:impactConfig>
					<rhImpactAnalysis:impactConfig rdf:parseType="Resource">
						<rhImpactAnalysis:profile rdf:resource="https://harbinger:9444/dm/impactconfig/33268a04-ba42-4669-8c66-660f32405261"></rhImpactAnalysis:profile>
						<rhImpactAnalysis:enableDeselecting rdf:datatype="http://www.w3.org/2001/XMLSchema#boolean">true</rhImpactAnalysis:enableDeselecting>
					</rhImpactAnalysis:impactConfig>
				</rhImpactAnalysis:ImpactConfigParam>
			</rhImpactAnalysis:hasGolbalImpactConfig>
			<rhImpactAnalysis:hasArtifactImpact>
				<rhImpactAnalysis:ImpactArtifact>
					<rhImpactAnalysis:artifactStatus>MAIN</rhImpactAnalysis:artifactStatus> --> can also be ADD , REMOVE
					<rhImpactAnalysis:artifact rdf:resource="https://harbinger:9444/dm/models/28"></rhImpactAnalysis:artifact>
				</rhImpactAnalysis:ImpactArtifact>
			</rhImpactAnalysis:hasArtifactImpact>
		</rhImpactAnalysis:ImpactAnalysis>
	</rdf:RDF>
	 */
	
	toXMLString: function() {
		var iaXML = '<?xml version="1.0" encoding="UTF-8"?> \n' ;
		iaXML+= '<rdf:RDF xmlns="' + XMLNS + 
		'"\n xmlns:dcterms="' + DC + 
		'"\n xmlns:rdf="'+ RDF +
		'"\n xmlns:' + IA_QUALIFIER + '="' + RH_IA + '"' +
		//'"\n xmlns:' + IAP_QUALIFIER + '="' + IAP_NAMESPACE + '"' +
		'>\n';

		var resourceUri = !this.uri ? '' : (' rdf:about="' + this.uri + '"');

		iaXML+='<rhImpactAnalysis:ImpactAnalysis'+ resourceUri +'>';

		//Diagram Info:
		iaXML+= this.fragmentNode(IA_QUALIFIER,IA_STATUS, jazz.util.html.escape(this.impactStatus), true);
		iaXML+= this.fragmentNode(IA_QUALIFIER,IA_NAME, jazz.util.html.escape(this.shortName), true);
		iaXML+= '<dcterms:description>' + jazz.util.html.escape(this.description) + '</dcterms:description>\n';
		if (this.contextConfigVersionUri)
			iaXML+= '<rhImpactAnalysis:contextConfigVersionUri>' + jazz.util.html.escape(this.contextConfigVersionUri) + '</rhImpactAnalysis:contextConfigVersionUri>\n';
		if (this.layout)
			iaXML+= '<rhImpactAnalysis:layout>' + this.layout + '</rhImpactAnalysis:layout>\n';
		iaXML+= '<rhImpactAnalysis:owner/>\n'; //todo
		iaXML+= '<rhImpactAnalysis:startDate/>\n';
		iaXML+= '<rhImpactAnalysis:impactDueDate/>\n';
		iaXML+= '<rhImpactAnalysis:closeDate/>\n';

		//Profile:
		iaXML+= '<rhImpactAnalysis:hasGolbalImpactConfig>\n';
	    iaXML+= '<rhImpactAnalysis:ImpactConfigParam>\n';
		iaXML+= this.fragmentResourceNode(IA_QUALIFIER, IA_TYPE, this.iAType, true);
		iaXML+= this.fragmentNode(IA_QUALIFIER, IA_REDUCE, this.iAReduceResult, true);
		iaXML+= this.fragmentNode(IA_QUALIFIER, IA_COMMENT, this.iAComment, false);

		var profileIncluded = this.iAIncludedProfile !== null;
		iaXML+= this.fragmentNode(IA_QUALIFIER, IA_PROFILE_INCLUDED, profileIncluded, true);
		if (profileIncluded)
			iaXML+= this.fragmentProfile(this.iAIncludedProfile);

		iaXML+= '</rhImpactAnalysis:ImpactConfigParam>\n';
		iaXML+= '</rhImpactAnalysis:hasGolbalImpactConfig>\n';


		//Focus Artifact:
		iaXML+= this.fragmentArtifact(this.targetResourceUri, ARTIFACT_MAIN );

		//added artifacts
		var i;
		for(i = 0; i < this.addedElements.length; i++) {
			iaXML += this.fragmentArtifact(this.addedElements[i], ARTIFACT_ADD);
		}
		//removed artifacts
		for(i = 0; i < this.removedElements.length; i++) {
			iaXML += this.fragmentArtifact(this.removedElements[i], ARTIFACT_REMOVE);
		}
		//quick filters
		for(i = 0; i < this.artifactQuickFilters.length; i++) {
			iaXML += this.fragmentArtifact(this.artifactQuickFilters[i], ARTIFACT_QUICK_FILTER);
		}
		//expansion sequence
		for(i = 0; i < this.expansionSequence.length; i++) {
			iaXML += this.fragmentArtifact(this.expansionSequence[i], ARTIFACT_EXPANSION_SEQUENCE);
		}


		iaXML+='</rhImpactAnalysis:ImpactAnalysis>';
		iaXML += '</rdf:RDF>\n';
		return iaXML;
	},
	
	/*
	 * <rhImpactAnalysis:hasArtifactImpact>
				<rhImpactAnalysis:ImpactArtifact>
					<rhImpactAnalysis:artifact rdf:resource="https://tp-sela.haifa.ibm.com:9444/rmps/models/1/1-4ba24ebb23ac10f4-O-8-000027c1"/>
					<rhImpactAnalysis:artifactStatus>MAIN</rhImpactAnalysis:artifactStatus> --> can also be ADD , REMOVE					
				</rhImpactAnalysis:ImpactArtifact>
			</rhImpactAnalysis:hasArtifactImpact>
	 */
	fragmentArtifact: function (artifactTypeUri ,artifactType )
	{
		var iaXML = "<rhImpactAnalysis:hasArtifactImpact>\n <rhImpactAnalysis:ImpactArtifact>\n";
       iaXML += this.fragmentNode(IA_QUALIFIER,IA_ARTIFACT_STATUS ,artifactType , true  ) ; 
       iaXML += this.fragmentResourceNode(IA_QUALIFIER ,IA_ARTIFACT ,artifactTypeUri ,true) ;
       iaXML += "</rhImpactAnalysis:ImpactArtifact> \n</rhImpactAnalysis:hasArtifactImpact>\n";
	   return iaXML;
	},
	
	fragmentNode: function(qn, property, value, not_encoded) {
		var adoptedValue= value? value.toString(): value;
		var xmlEncoded = not_encoded ?  value : dojox.html.entities.encode(adoptedValue);
		if (xmlEncoded === null)
		{
			return "<" + qn + ":"+ property +"></" + qn + ":"+ property +">\n";
		}
		else{
			return "<" + qn + ":"+ property +">" + xmlEncoded + "</" + qn + ":"+ property +">\n";
		}
		
	},

	fragmentNodeWithType: function(qn, property, value, not_encoded, type) {
		var adoptedValue = value ? value.toString() : value;
		var xmlEncoded = not_encoded ? value : dojox.html.entities.encode(adoptedValue);
		var datatype = type === null ? "" : "rdf:datatype=\"" + type + "\"";
		if (xmlEncoded === null) {
			return "<" + qn + ":" + property + "></" + qn + ":" + property + ">\n";
		} else {
			return "<" + qn + ":" + property + " " + datatype + ">" + xmlEncoded + "</" + qn + ":" + property + ">\n";
		}
	},
	
	fragmentResourceNode: function(qn, property, value, not_encoded) {
		var adoptedValue= value? value.toString(): value;
		var xmlEncoded = not_encoded ?  value : dojox.html.entities.encode(adoptedValue);
		if (xmlEncoded === null)
		{
			return '<' + qn + ':'+ property +' rdf:resource=""/>\n';
		}
		else{
			return '<' + qn + ':'+ property +' rdf:resource="' + xmlEncoded + '"/>\n';
		}
	},

	fragmentProfile: function(profile){
		var xmlString = "";
		
		xmlString += this.fragmentNodeWithType(IA_QUALIFIER, "traversal", jazz.util.html.escape(profile.traversal), true, null);

		if (profile.upstreamType !== "")
			xmlString += this.fragmentResourceNode(IA_QUALIFIER, "upstreamType", profile.upstreamType, true);
		else if (profile.upstreamDepth)
			xmlString += this.fragmentNodeWithType(IA_QUALIFIER, "upstreamDepth", profile.upstreamDepth, false, INT);

		if (profile.downstreamType !== "")
			xmlString += this.fragmentResourceNode(IA_QUALIFIER, "downstreamType", profile.downstreamType, true);
		else if (profile.downstreamDepth)
			xmlString += this.fragmentNodeWithType(IA_QUALIFIER, "downstreamDepth", profile.downstreamDepth, false, INT);
		
		if (profile.fullTraceType !== "")
			xmlString += this.fragmentResourceNode(IA_QUALIFIER, "fullTraceType", profile.fullTraceType, true);
		else if (profile.fullTraceDepth)
			xmlString += this.fragmentNodeWithType(IA_QUALIFIER, "fullTraceDepth", profile.fullTraceDepth, false, INT);
		
		dojo.forEach(profile.filters, function(filter) {
			xmlString += this.fragmentFilter(filter);
		}, this);


		return xmlString;
	},

	fragmentFilter: function(filter){
		/*
		<rhImpactAnalysis:impactConfig rdf:parseType="Resource">
			<rhImpactAnalysis:profile rdf:resource="https://harbinger:9444/dm/impactconfig/33268a04-ba42-4669-8c66-660f32405261"></rhImpactAnalysis:profile>
		</rhImpactAnalysis:impactConfig>
		*/

		var xml = "";
		var configUri = filter.uri ? filter.uri.toString() : filter.uri;

		xml += '<' + IA_QUALIFIER + ':impactConfig rdf:parseType="Resource">\n';
			xml += '<' + IA_QUALIFIER + ':profile rdf:resource=\"' + dojox.html.entities.encode(configUri) + '\"></' + IA_QUALIFIER + ':profile>\n';
		xml += '</' + IA_QUALIFIER + ':impactConfig>\n';

		return xml;
	},
	
	getEmptyImpactanalysis: function()
	{
		var date = dojo.date.locale.format(new Date(), {formatLength: "medium"});
		var iaXML = '<?xml version="1.0" encoding="UTF-8"?> <rdf:RDF\n'+
		'xmlns:dcterms="http://purl.org/dc/terms/"\n'+
		'xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"\n'+
		'xmlns:rhImpactAnalysis="http://jazz.net/xmlns/rh/impacAnalysis/1.0/">\n'+
			'<rhImpactAnalysis:ImpactAnalysis>\n'+
			' <dcterms:description></dcterms:description> \n'+   
		    '<rhImpactAnalysis:impactStatus>Draft</rhImpactAnalysis:impactStatus>\n'+
		    '<rhImpactAnalysis:owner></rhImpactAnalysis:owner>\n'+
		    '<rhImpactAnalysis:impactName>My Impact Analysis-'+ date +'</rhImpactAnalysis:impactName>\n'+
		    '<rhImpactAnalysis:closeDate></rhImpactAnalysis:closeDate>\n'+
		    '<rhImpactAnalysis:impactDueDate></rhImpactAnalysis:impactDueDate> \n'+   
		    '<rhImpactAnalysis:startDate></rhImpactAnalysis:startDate>\n';
		 if (this.targetResourceUri)
		 {
			 iaXML+= this.fragmentArtifact(this.targetResourceUri ,ARTIFACT_MAIN );
		 } 
		iaXML +='</rhImpactAnalysis:ImpactAnalysis>\n';
		iaXML +='</rdf:RDF>\n';
		 
		return iaXML;
	},

	parse: function(iaNode, ioArgs) {
		if (ioArgs) {
			var xhr = ioArgs.xhr;
			if (xhr.getResponseHeader("ETag")) {
				this.eTag = xhr.getResponseHeader("ETag");
			}
			if (xhr.getResponseHeader("Location")) {
				this.uri = xhr.getResponseHeader("Location");
			}
		}
		this.addedElements = [];
		this.removedElements = [];
		this.artifactQuickFilters = [];
		this.parseNodes(iaNode);
	},
	
	parseNodes: function(iaNode)
	{
		var i;
		for( i = 0 ; i < iaNode.childNodes.length; i++) {
		   var node = iaNode.childNodes[i];
		   if (node.nodeName === "rhImpactAnalysis:impactStatus") {
				if (node.childNodes.length > 0) 
				{
					this.impactStatus = node.childNodes[0].nodeValue;
				}
			}
			else if (node.nodeName === "rhImpactAnalysis:impactName") {
				if (node.childNodes.length > 0) 
				{
					this.shortName = node.childNodes[0].nodeValue;
				}
			}
			else if (node.nodeName === "rhImpactAnalysis:hasGolbalImpactConfig") {
				this.getGlobalConfig(node);
			}	
			else if (node.nodeName === "rhImpactAnalysis:hasArtifactImpact") {
				this.getArtifact(node);
			}
			else if (node.nodeName === "rhImpactAnalysis:contextConfigVersionUri") {
				if (node.childNodes.length > 0) 
				{
					this.contextConfigVersionUri = node.childNodes[0].nodeValue;
				}
			}
			else if (node.nodeName === "rhImpactAnalysis:layout") {
				if (node.childNodes.length > 0) 
				{
					this.layout = node.childNodes[0].nodeValue;
				}
			}
			else{
				if (node.childNodes) {
					this.parseNodes(node);
				}
			}		
		}
	},
	
	
	/*
	 * <rhImpactAnalysis:hasArtifactImpact>
				<rhImpactAnalysis:ImpactArtifact>
					<rhImpactAnalysis:artifact rdf:resource="https://tp-sela.haifa.ibm.com:9444/rmps/models/1/1-4ba24ebb23ac10f4-O-8-000027c1"/>
					<rhImpactAnalysis:artifactStatus>MAIN</rhImpactAnalysis:artifactStatus> --> can also be ADD , REMOVE					
				</rhImpactAnalysis:ImpactArtifact>
			</rhImpactAnalysis:hasArtifactImpact>
	 */
	getArtifact: function(iaNode)
	{
		var artifacttype;
		var artifactUri;
		
		var i;
		for( i = 0 ; i < iaNode.childNodes.length; i++) {
		   var node = iaNode.childNodes[i];
		   if (node.nodeName === "rhImpactAnalysis:artifact") {
				if (node.attributes.length > 0) 
				{
					artifactUri = node.attributes[0].nodeValue;
				}
			}
			else if (node.nodeName === "rhImpactAnalysis:artifactStatus") {
				if (node.childNodes.length > 0) 
				{
					artifacttype = node.childNodes[0].nodeValue;
				}
			}
			else
			{
				if (node.childNodes) {
					this.getArtifact(node);
				}
			}
		}
		
		if (artifacttype === ARTIFACT_ADD)
		{
			this.addedElements[this.addedElements.length] = artifactUri;
		}
		else if (artifacttype === ARTIFACT_MAIN)
		{
			this.targetResourceUri = artifactUri; 
		}
		else if (artifacttype === ARTIFACT_REMOVE)
		{
			this.removedElements[this.removedElements.length] = artifactUri;
		}
		else if (artifacttype === ARTIFACT_QUICK_FILTER)
		{
			this.artifactQuickFilters.push(artifactUri);
		}
		else if (artifacttype === ARTIFACT_EXPANSION_SEQUENCE)
		{
			this.expansionSequence.push(artifactUri);
		}
	},
	getGlobalConfig: function(iaNode)
	{
		 var i;
		 for (i = 0; i < iaNode.childNodes.length; i++) {
			 var node = iaNode.childNodes[i];

			 if (node.nodeName === "rhImpactAnalysis:configType") {
				if (node.attributes.length > 0) 
				{
					this.iAType = node.attributes[0].nodeValue;
				}
			 }
			 else if (node.nodeName === "rhImpactAnalysis:configIsReduced") {
				 var val;
				 if (node.childNodes.length > 0) {
					 val = node.childNodes[0].nodeValue;
				 }
				 if (val) {
					 this.iAReduceResult = val === "true";
				 }
			}
			 else if (node.nodeName === "rhImpactAnalysis:configComment") {
				if (node.childNodes.length > 0) 
				{
					this.iAComment = node.childNodes[0].nodeValue;
				}
			 }
			else{
				if (node.childNodes) {
					this.getGlobalConfig(node);
				}
			}	
			
		 }
	}
});

}());