/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.analysis.app.ui.internal.impactanalysis.models.RHImpactClient");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.models.ImpactAnalysis");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.models.ImpactAnalysisConfig");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.models.ImpactAnalysisProfile");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.ProgressDialog");
dojo.require("dojox.xml.DomParser");

dojo.require("jazz.app.context");
dojo.require("jazz.client.xhr");

dm.analysis.app.ui.internal.impactanalysis.models.RHImpactClient = {
	//view Type - by structure = 1 by systems = 2
	perfomImpact: function(projectArea, resourceUri , depth , direction , reduceResult , impactld, filter) {
		
		var queryParams = {
			"source": resourceUri ,
			"impactType": direction ,
			"depth": depth,
			"reduced": reduceResult,
			"impactld" : impactld,
			"filter" : filter,
			"projectArea" : projectArea
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			url: net.jazz.ajax._contextRoot + "/rhimpact?" + dojo.objectToQuery(queryParams),
			handleAs: "json",
			timeout: 10000000,
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrGet(args);
	},
	
	getLDTypes: function(projectID) {
		
		var queryParams = {
			"projectID": projectID
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		
		var args = {
			url: net.jazz.ajax._contextRoot + "/allviewmodels?" + dojo.objectToQuery(queryParams),
			handleAs: "json",
			timeout: 10000000,
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs){
				return response;
			},
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrGet(args);
	},
	
	getImpactFiltersTypes: function() {
		
		var queryParams = {
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		
		var args = {
			url: net.jazz.ajax._contextRoot + "/rhimpactfilters?" + dojo.objectToQuery(queryParams),
			handleAs: "json",
			timeout: 10000000,
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs){
				return response;
			},
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrGet(args);
	},

	//https://tp-sela.haifa.ibm.com:9444/rmps/impactanalysis?projectId=_U-FM8OaEEd-WEbFUgpxAaA&action=json
	getAllImpacted: function(projectId , groupUri) {
		var queryParams = {};
		if (groupUri != null) {
			queryParams = {
				"projectId": projectId,
				"groupUri": groupUri,
				"action":"json"};
			
		}
		else{
			queryParams = {
				"projectId": projectId,
				"action":"json"
			};
			
		}
		
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}

		var args = {
			url: net.jazz.ajax._contextRoot + "/impactanalysis?" + dojo.objectToQuery(queryParams),
			handleAs: "json",
			timeout: 10000000,
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs){
				return response;
			},
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrGet(args);
	},
	
	//https://tp-sela.haifa.ibm.com:9444/rmps/impactconfig?projectId=_U-FM8OaEEd-WEbFUgpxAaA&action=json
	getAllIAConfigs: function(projectId ) {
		var queryParams = {
				"projectId": projectId,
				"action":"json"
			};
		
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		
		var args = {
			url: net.jazz.ajax._contextRoot + "/impactconfig?" + dojo.objectToQuery(queryParams),
			handleAs: "json",
			timeout: 10000000,
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs){
				return response;
			},
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrGet(args);
	},

	//https://harbinger:9444/rmps/impactprofile?projectId=_U-FM8OaEEd-WEbFUgpxAaA&action=json
	getAllIAProfiles: function(projectId) {
		var queryParams = {
				"projectId": projectId,
				"action":"json"
			};
		
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		
		var args = {
			url: net.jazz.ajax._contextRoot + "/impactprofile?" + dojo.objectToQuery(queryParams),
			handleAs: "json",
			timeout: 10000000,
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs){
				return response;
			},
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrGet(args);
	},

	getImpactTypes: function() {
		
		var queryParams = {
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			url: net.jazz.ajax._contextRoot + "/rhimpacttypes?" + dojo.objectToQuery(queryParams),
			handleAs: "json",
			timeout: 10000000,
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrGet(args);
	},
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////	
	// https://tp-sela.haifa.ibm.com:9444/rmps/impactanalysis/results/<impact_id> 
	getImpactAnalysisResult: function(impact_id) {
		var queryParams = {"action": "json" };
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true"
			},
			url: net.jazz.ajax._contextRoot + "/impactanalysis/results/" + impact_id + "?" + dojo.objectToQuery(queryParams),
			handleAs: "json",
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrGet(args);
	},

	//POST impactanalysis/compute?projectId=xxx
	//ia - impact definition needed for computation
	//progmessage - (optional) progress indicator message to display to the user
	computeImpactAnalysis: function (ia, progmessage) {
		// Invoke an impact analysis computation for the passed impact analysis model.
		// Returns a Dojo deferred object.

		var queryParams = { projectId: jazz.app.context.get().itemId };

		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		
		var args = {
			explanation: progmessage,
			showDialogInMillis: 500,
			headers: {
				"Content-Type": "application/rdf+xml",
				"X-ibm-rmps-internal": "true"
			},
			url: net.jazz.ajax._contextRoot + "/impactanalysis/compute" + "?" + dojo.objectToQuery(queryParams),
			postData: ia.toXMLString(),
			handleAs: "json",
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		//Uses an overlay progress indicator to prevent user from performing other actions while this
		//xhr call is being fulfilled. This uses regular jazz.client.xhrPost(args).
		return dm.analysis.app.ui.internal.impactanalysis.ProgressDialog.slowXhrPost(args);
	},

	//https://tp-nirm.haifa.ibm.com:9444/rmps/impactanalysis/fe658fb1-627e-4a47-bacd-00645f7d3823
	getImpactAnalysis: function(impact_uri) {
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true"
			},
			url: impact_uri ,
			handleAs: "text",
			load: function(response, ioArgs)
			{
				var ia = new dm.analysis.app.ui.internal.impactanalysis.models.ImpactAnalysis();
				ia.uri = impact_uri;
				ia.resourceUri = impact_uri;
				ia.parse(dojox.xml.DomParser.parse(response), ioArgs);
				return ia;
			},
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrGet(args);
	},
	//https://tp-nirm.haifa.ibm.com:9444/rmps/impactanalysis/6e1e5b2c-eb06-476f-99f5-a54336ea060f
	createImpactAnalysis: function(ia) {
		var projectId = jazz.app.context.get().itemId;
		var queryParams = {
			"projectId": projectId
		};
		
		if(ia) {
			ia.created = new Date();
		}
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true",
				"Content-Type": "application/rdf+xml",
				"Accept": "application/atom+json"
			},
			url: net.jazz.ajax._contextRoot + "/impactanalysis?" + dojo.objectToQuery(queryParams),
			handleAs: "json",
			hasBody: true,
			postData: ia ? ia.toXMLString() : null,
			load: dojo.hitch(this, function(response, ioArgs)
			{
				ia.created = new Date(ioArgs.xhr.getResponseHeader("created"));
				ia.eTag = ioArgs.xhr.getResponseHeader("ETag");
				var iaUri = ioArgs.xhr.getResponseHeader("Location"); 
				ia.uri = iaUri;
				ia.resourceUri = iaUri;
				return ia;
			}),
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrPost(args);
	},
	
	updateImpactAnalysis: function (ia) {
		var queryParams = {projectId: jazz.app.context.get().itemId};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			dojo.mixin(queryParams, {"rmps.context": jazz.app.context.get().baseline});
		}
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true",
				"Content-Type": "application/rdf+xml",
				"If-Match": ia.eTag,
				"ETag": ia.eTag
			},
			url: ia.uri + "?" + dojo.objectToQuery(queryParams),
			handleAs: "text",
			hasBody: true,
			putData: ia.toXMLString(),
			load: dojo.hitch(this, function(response, ioArgs)
			{
				ia.eTag = ioArgs.xhr.getResponseHeader("ETag");
				return ia;
			}),
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrPut(args);
	},
	
	deleteImpactAnalysis: function(ia) {
		var queryParams = {projectId: jazz.app.context.get().itemId};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true",
				"Content-Type": "application/rdf+xml",
				"If-Match": ia.eTag,
				"ETag": ia.eTag
			},
			url: ia.uri + "?" + dojo.objectToQuery(queryParams),
			handleAs: "text",
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrDelete(args); 
	},

//////////////////////////////////////////////////////////////impact profile /////////////////
	getIAProfile: function(impactProfile_uri){
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true"
			},
			url: impactProfile_uri,
			handleAs: "text",
			load: function(response, ioArgs){
				var iap = new dm.analysis.app.ui.internal.impactanalysis.models.ImpactAnalysisProfile();
				iap.uri = impactProfile_uri;
				iap.resourceUri = impactProfile_uri;
				iap.parse(dojox.xml.DomParser.parse(response), ioArgs);	
				return iap;
			},
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrGet(args);
	},

	createIAProfile: function(iap){
		var projectId = jazz.app.context.get().itemId;
		var date = dojo.date.locale.format(new Date(), {formatLength: "medium"});
		var queryParams = {
			projectId: projectId
		};
		
		if(iap) {
			iap.created = new Date();
		}
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true",
				"Content-Type": "application/rdf+xml",
				"Accept": "application/atom+json"
			},
			handleAs: "text",
			hasBody: true,
			postData: iap ? iap.toXMLString() : null,
			url: net.jazz.ajax._contextRoot + "/impactprofile?" + dojo.objectToQuery(queryParams),
			load: dojo.hitch(this, function(response, ioArgs)
			{
				iap.created = new Date(ioArgs.xhr.getResponseHeader("created"));
				iap.eTag = ioArgs.xhr.getResponseHeader("ETag");
				var iaUri = ioArgs.xhr.getResponseHeader("Location"); 
				iap.uri = iaUri;
				iap.resourceUri = iaUri;
				return iap;
			}),
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrPost(args);
	},

	updateIAProfile: function(iap) {
		var queryParams;
		
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true",
				"Content-Type": "application/rdf+xml",
				"If-Match": iap.eTag,
				"ETag": iap.eTag
			},
			url: iap.uri ,
			handleAs: "text",
			hasBody: true,
			putData: iap.toXMLString(),
			load: dojo.hitch(this, function(response, ioArgs)
			{
				iap.eTag = ioArgs.xhr.getResponseHeader("ETag");
				return iap;
			}),
			error: function(response, ioArgs) {
				console.error(response);
			}
		};

		return jazz.client.xhrPut(args);
	},

	deleteIAProfile: function(iap, validate){
		var queryParams = {
			validate: validate,
			projectId: jazz.app.context.get().itemId
		};
		
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true",
				"Content-Type": "application/rdf+xml",
				"If-Match": iap.eTag,
				"ETag": iap.eTag
			},
			url: iap.uri +"?" + dojo.objectToQuery(queryParams) ,
			handleAs: "text",
			error: function(response, ioArgs) {
				console.error(response);
			}
		};

		return jazz.client.xhrDelete(args);
	},

	deleteIAProfiles: function(profiles){
		var queryParams = {
			projectId: jazz.app.context.get().itemId
		};
		
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}

		return jazz.client.xhrDelete({
			url: net.jazz.ajax._contextRoot + '/impactprofile' +"?" + dojo.objectToQuery(queryParams),
			handleAs: "text",
			headers: {
				"X-ibm-rmps-internal": "true",
				"Content-Type": "application/rdf+xml"
			},
			content: {
				profileUris: dojo.map(profiles, function(profile) {
					return profile.URI;
				})
			},
			error: function(response, ioArgs) {
				console.error(response);
			}
		});
	},

//////////////////////////////////////////////////////////////impact config //////////////////
//https://tp-nirm.haifa.ibm.com:9444/rmps/impactconfig/fe658fb1-627e-4a47-bacd-00645f7d3823
	getIAConfig: function(impactConfig_uri) {
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true"
			},
			url: impactConfig_uri ,
			handleAs: "text",
			load: function(response, ioArgs)
			{
				var iac = new dm.analysis.app.ui.internal.impactanalysis.models.ImpactAnalysisConfig();
				iac.uri = impactConfig_uri;
				iac.resourceUri = impactConfig_uri;
				iac.parse(dojox.xml.DomParser.parse(response), ioArgs);	
				return iac;
			},
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrGet(args);
	},
	//https://tp-nirm.haifa.ibm.com:9444/rmps/impactconfig
	createIAConfig: function(iac) {
		var projectId = jazz.app.context.get().itemId;
		var date = dojo.date.locale.format(new Date(), {formatLength: "medium"});
		var queryParams = {
			projectId: projectId
		};
		
		if(iac) {
			iac.created = new Date();
		}
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true",
				"Content-Type": "application/rdf+xml",
				"Accept": "application/atom+json"
			},
			handleAs: "text",
			hasBody: true,
			postData: iac ? iac.toXMLString() : null,
			url: net.jazz.ajax._contextRoot + "/impactconfig?" + dojo.objectToQuery(queryParams),
			load: dojo.hitch(this, function(response, ioArgs)
			{
				iac.created = new Date(ioArgs.xhr.getResponseHeader("created"));
				iac.eTag = ioArgs.xhr.getResponseHeader("ETag");
				var iaUri = ioArgs.xhr.getResponseHeader("Location"); 
				iac.uri = iaUri;
				iac.resourceUri = iaUri;
				return iac;
			}),
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrPost(args);
	},
	
	updateIAConfig: function(iac) {
		var queryParams;
		
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true",
				"Content-Type": "application/rdf+xml",
				"If-Match": iac.eTag,
				"ETag": iac.eTag
			},
			url: iac.uri ,
			handleAs: "text",
			hasBody: true,
			putData: iac.toXMLString(),
			load: dojo.hitch(this, function(response, ioArgs)
			{
				iac.eTag = ioArgs.xhr.getResponseHeader("ETag");
				return iac;
			}),
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrPut(args);
	},
	
	deleteIAFilter: function(filter, validate) {
		var queryParams = {
			validate: validate,
			projectId: jazz.app.context.get().itemId
			};
			
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true",
				"Content-Type": "application/rdf+xml",
				"If-Match": filter.eTag,
				"ETag": filter.eTag
			},
			url: filter.uri +"?" + dojo.objectToQuery(queryParams) ,
			handleAs: "text",
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return jazz.client.xhrDelete(args); 
	},

	deleteIAFilters: function(filters){
		var queryParams = {
			projectId: jazz.app.context.get().itemId
		};
		
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}

		return jazz.client.xhrDelete({
			url: net.jazz.ajax._contextRoot + '/impactconfig' +"?" + dojo.objectToQuery(queryParams),
			handleAs: "text",
			headers: {
				"X-ibm-rmps-internal": "true",
				"Content-Type": "application/rdf+xml"
			},
			content: {
				configUris: dojo.map(filters, function(filter) {
					return filter.URI;
				})
			},
			error: function(response, ioArgs) {
				console.error(response);
			}
		});
	},
};

}());