/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.analysis.app.ui.internal.impactanalysis.pages.ImpactAnalysisPage");

dojo.require("dijit._Widget");

dojo.require("rmps.ui.editor.EditorRegistry");
dojo.require("rmps.ui.editor.EditorUtil");
dojo.require("rmps.ui.editor.EditorView");
dojo.require("rmps.ui.editor.AbstractPage");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisInput");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisController");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.AllImpactAnalysisesInput");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisesForGroupInput");

dojo.require("dm.analysis.app.ui.internal.impactanalysis.config.AllIAConfigsInput");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.config.IAConfigInput");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.profile.AllIAProfilesInput");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.profile.IAProfileInput");

dojo.require("dm.analysis.app.ui.internal.impactanalysis.pages.AnalysisWelcome");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.IASideNavigation");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisEditor");


dojo.require("net.jazz.ajax.ui.PlatformUI");

dojo.require("jazz.app.context");

dojo.require("jazz.util.ResizeNotifier");

dojo.require("dojo.i18n");
dojo.config.useGfxLayout = true;


dojo.requireLocalization("dm.analysis.app.ui.internal.impactanalysis.pages", "DMAnalysisMessages"); 
var messages = dojo.i18n.getLocalization("dm.analysis.app.ui.internal.impactanalysis.pages", "DMAnalysisMessages"); 

var PlatformUI = net.jazz.ajax.ui.PlatformUI;
var PAGE_ID = "dm.app.impactanalysis";
var PAGE_REMOVAL_ID = "dm.app.impactanalysis.removePage";
var ACTION_PREFIX = "dm.app.impactanalysis.";
var ACTIONS_LIST = [
	"_default",
	"impactAnalysis",
	"allImpacts",
	"allIAConfigs",
	"allIAProfiles",
	"iaConfig",
	"iaProfile",
	"welcome"
];
//var defultIAPresURI = "#action=dm.app.impactanalysis.impactAnalysis&id=dm.app.impactanalysis";
dojo.declare("dm.analysis.app.ui.internal.impactanalysis.pages.ImpactAnalysisPage", [rmps.ui.editor.AbstractPage], {
	
	messages: null,
	// private properties
	_controller: null,
	_editorView: null,
	_sideNav: null,
	_status: null,
	_resizeHandle: null,	
	_statusSection: null,
	_treeSection:null,
	_searchBanner: null,
	// editors
	_impactAnalysis: null,
	_projectID:null,
	_resourceInfo:null,
	_impactUri:null,
	_allImpactsInput:null,
	_treeSectionDiv:null,
	_allIAConfigsInput:null,
	_welcome:null,
	
		
	postCreate: function() {
		
		this._projectID  = jazz.app.context.get().itemId;
		//get URI
		var defaultUrl = dojo.hash();
		//get the parameters from the URI
		var uriObj = dojo.queryToObject(defaultUrl);
		//get source data XHR call
		var resourceUri = uriObj.resourceUri;
		var create = uriObj.create; 
		this.targetUri = uriObj.targetUri;
		this._controller = new dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisController(this);
		
		rmps.ui.editor.EditorRegistry.register("dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisEditor", function(editorInput) {
			return editorInput instanceof dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisInput;});
		
		rmps.ui.editor.EditorRegistry.register("dm.analysis.app.ui.internal.impactanalysis.config.IAConfigEditor", function(editorInput) {
			return editorInput instanceof dm.analysis.app.ui.internal.impactanalysis.config.IAConfigInput;});

		rmps.ui.editor.EditorRegistry.register("dm.analysis.app.ui.internal.impactanalysis.profile.IAProfileEditor", function(editorInput) {
			return editorInput instanceof dm.analysis.app.ui.internal.impactanalysis.profile.IAProfileInput;});
		
		rmps.ui.editor.EditorRegistry.register("dm.analysis.app.ui.internal.impactanalysis.AllImpactAnalysisesEditor", function(editorInput) {
			return editorInput instanceof dm.analysis.app.ui.internal.impactanalysis.AllImpactAnalysisesInput;});
		
		rmps.ui.editor.EditorRegistry.register("dm.analysis.app.ui.internal.impactanalysis.config.AllIAConfigsEditor", function(editorInput) {
			return editorInput instanceof dm.analysis.app.ui.internal.impactanalysis.config.AllIAConfigsInput;});

		rmps.ui.editor.EditorRegistry.register("dm.analysis.app.ui.internal.impactanalysis.profile.AllIAProfilesEditor", function(editorInput) {
			return editorInput instanceof dm.analysis.app.ui.internal.impactanalysis.profile.AllIAProfilesInput;});
		
		rmps.ui.editor.EditorRegistry.register("dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisesForGroupEditor", function(editorInput) {
			return editorInput instanceof dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisesForGroupInput;});
		
		this._allImpactsInput = new dm.analysis.app.ui.internal.impactanalysis.AllImpactAnalysisesInput( { });
		
		this._allIAConfigsInput = new dm.analysis.app.ui.internal.impactanalysis.config.AllIAConfigsInput( { });

		this._allIAProfilesInput = new dm.analysis.app.ui.internal.impactanalysis.profile.AllIAProfilesEditor( { });
		
		this.inherited(arguments);
	
	},
	
	
	/*

	resize: function() {
		if (PlatformUI.getWorkbench().currentPageId == PAGE_ID) {
			var contentCell = dojo.byId("content-cell");
			var c1 = dojo.coords(contentCell, true);
			var c2 = dojo.coords(this.domNode, true);
			var height = (parseInt(contentCell.style.height) || parseInt(contentCell.style.minHeight)) + c1.y - c2.y;
			this._sideNav.resize({ h: height });
		}
	},
	*/
	
	////////////////////////////////////////////////////////////
	createPageContents: function(){
		// init side navigation
		this._treeSectionDiv = dojo.doc.createElement("div" );
		this._sideNav = new dm.analysis.app.ui.internal.impactanalysis.IASideNavigation({
			pageId: PAGE_ID,
			tree: this._treeSectionDiv
		});
		this.addChild(this._sideNav);
		this.inherited(arguments);
	},


	/*Side navigation is the owing view */
	getView: function(){
		return this._sideNav;
	},
	
	/*The appending view must be the content container for the side navigation */
	getContainerNode: function(){
		return this._sideNav.getContentContainer();
	},
	
	getPageRemovalId: function(){
		return PAGE_REMOVAL_ID;
	},
	
	subscribeActions: function(){
		this.subscribeAllActions(this._controller);	
	},
	
	registerActions: function(){
		this.registerActionsList(ACTIONS_LIST);
	},
	
	getPageId: function(){
		return PAGE_ID;
	},
	///////////////////////////////////////////////////////////////
	showWelcome: function() {
		if (!this._welcome) {
			this._welcome = new dm.analysis.app.ui.internal.impactanalysis.pages.AnalysisWelcome();
		}
		this._sideNav.addContent(this._welcome);
		this.pageHelper.clearLastViewed();
		net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(messages.welcomeToAnalysis);
	},
	
	showIAConfig: function(resourceUri ,args) {
		var editorInput = new dm.analysis.app.ui.internal.impactanalysis.config.IAConfigInput(
		                       {projectId:this._projectID , resourceUri: resourceUri });
		var editorView = this.getEditorView();
		this._sideNav.addContent(editorView);
		this.pageHelper.openEditor(editorInput);
	},
	
	showAllIAConfigs: function(args) {
		var editorView = this.getEditorView();
		this._sideNav.addContent(editorView);
		this.pageHelper.openEditor(this._allIAConfigsInput);
	},
	
	showImpactAnalysis: function(resourceUri ,args) {
		var editorInput = new dm.analysis.app.ui.internal.impactanalysis.ImpactAnalysisInput(
		                       {projectId:this._projectID , resourceUri: resourceUri ,treeSideNav: this._treeSectionDiv, mainSideNav:this._sideNav  });
		var editorView = this.getEditorView();
		this._sideNav.addContent(editorView);
		this.pageHelper.openEditor(editorInput);
	},
	
	showAllImpacts: function(args) {
		var editorView = this.getEditorView();
		this._sideNav.addContent(editorView);
		this.pageHelper.openEditor(this._allImpactsInput);
	},

	showIAProfile: function(resourceUri, args){
		var editorInput = new dm.analysis.app.ui.internal.impactanalysis.profile.IAProfileInput(
		                       { projectId: this._projectID, resourceUri: resourceUri });
		var editorView = this.getEditorView();
		this._sideNav.addContent(editorView);
		this.pageHelper.openEditor(editorInput);
	},

	showAllIAProfiles: function(args){
		var editorView = this.getEditorView();
		this._sideNav.addContent(editorView);
		this.pageHelper.openEditor(this._allIAProfilesInput);
	}
});

})();


