/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.analysis.app.ui.internal.impactanalysis.panels.AddElementListPanel");

dojo.require("dijit._Widget");

dojo.require("dm.analysis.app.ui.internal.impactanalysis.panels.ElementListPanel");
dojo.require("dm.analysis.app.ui.internal.impactanalysis.picker.LocateElementControler");
dojo.require("dm.common.app.ui.internal.rhlink.IAInfoClient");

dojo.requireLocalization("dm.analysis.app.ui.internal.impactanalysis.panels", "ImpactAnalysisPanelsMessages"); 
var messages = dojo.i18n.getLocalization("dm.analysis.app.ui.internal.impactanalysis.panels", "ImpactAnalysisPanelsMessages");

dojo.declare(
	"dm.analysis.app.ui.internal.impactanalysis.panels.AddElementListPanel",
	dm.analysis.app.ui.internal.impactanalysis.panels.ElementListPanel , 
	{
		messages:messages,
		locateController:null,
		iconType: "remove",

		startup: function(){
			this.load(this.editor.editorInput.impactAnalysis.addedElements); 
			this.locateController = new dm.analysis.app.ui.internal.impactanalysis.picker.LocateElementControler();
		},

		updateToolbar: function(toolbar)
		{
			toolbar.addButton(this, dojo.hitch(this, this.handleAddElement), {
				label: messages.add,
				imgSrc: dojo.moduleUrl("dm.common.app", "graphics/icons/add.gif")
			});
		},
		
		handleAddElement: function() {
			this.locateController.locateElement(this);
		},
		
		updateAfterLocate: function (sourceURI)
		{
			this.editor.editorInput.impactAnalysis.addedElements.push(sourceURI);

			//TODO: MessageBox that says: "Adding..." to indicate that we're waiting for this
			var deferred = dm.common.app.ui.internal.rhlink.IAInfoClient.getInfo(sourceURI);
			deferred.addCallback(this, function(infos) {
				this.addElement(infos[0].uri, infos[0].shortName, infos[0].type, false);

				this.listChangeCallback && this.listChangeCallback();
			}); 

		},
		
		//override	
		restoreElement: function(row, listPanel)
		{
			var ia = listPanel.editor.editorInput.impactAnalysis;
			for(var i = 0 ; i < ia.addedElements.length; i++)
			{
				if (ia.addedElements[i] === row.uri)
				{
					ia.addedElements.splice(i,1);
					break;
				}
			}
			//add warning message , to do save , to do execute

			this.listChangeCallback && this.listChangeCallback();
		}

	});

})();
