/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.analysis.app.ui.internal.impactanalysis.panels.CommentPanel");

dojo.require("dijit._Widget");
dojo.require("dijit.form.SimpleTextarea");
dojo.require("dojo.i18n");

dojo.requireLocalization("dm.analysis.app.ui.internal.impactanalysis.panels", "ImpactAnalysisPanelsMessages");
var messages = dojo.i18n.getLocalization("dm.analysis.app.ui.internal.impactanalysis.panels", "ImpactAnalysisPanelsMessages");
var DIRTY_GROUP_ID = "dm.analysis.app.ui.internal.impactanalysis.panels.CommentPanel.dirty";

dojo.declare(
	"dm.analysis.app.ui.internal.impactanalysis.panels.CommentPanel", 
	[dijit._Widget, dijit._Templated], 
	{
		messages: messages,
		widgetsInTemplate: true,
		templateString: '<div dojoAttachPoint="commentContainer" style="overflow: auto; padding: 0px; height: 100%; width: 100%">'+
			'<div style="padding-bottom: 3px"><label for="${_tabCommentId}">${messages.commentLabel}</label></div>'+
			'<textarea dojoType="dijit.form.SimpleTextarea" style="height: 50%; width: 95%" dojoAttachPoint="_commentText" id="${_tabCommentId}" rows="10" cols="22"></textarea>'+
		'</div>',
		
		// init properties
		editor: null,
		
		constructor: function(args){
			//<label for="${_tabCommentId}">
			// id="${_tabCommentId}" (in SimpleTextarea)
			this._tabCommentId = dijit.getUniqueId("dm.analysis.app.ui.internal.impactanalysis.panels.CommentPanel.label");
		},

		postCreate: function(){
			var ia = this.editor.editorInput.impactAnalysis;
			if (ia.iAComment) {
				this._commentText.set('value', ia.iAComment);
			}

			this.connect(this._commentText, "onChange", dojo.hitch(this, function(newValue) {
				this.editor._updateDirty(ia.iAComment, this._commentText.get('value'), this._commentText);
			}));
		},

		resize: function(size){
			if (size && size.h) {
				dojo.marginBox(this.domNode, {h: size.h});
			}
		},

		getCommentText: function(){
			return this._commentText.get('value');
		}

	});

}());
