/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.analysis.app.ui.internal.impactanalysis.panels.TreeNavigationPanel");

dojo.require("dijit._Widget");

dojo.require("dojo.string");
dojo.require("dojo.i18n");

dojo.requireLocalization("dm.analysis.app.ui.internal.impactanalysis.panels", "ImpactAnalysisPanelsMessages"); 
var messages = dojo.i18n.getLocalization("dm.analysis.app.ui.internal.impactanalysis.panels", "ImpactAnalysisPanelsMessages");


dojo.declare("dm.analysis.app.ui.internal.impactanalysis.panels.TreeNavigationPanel", [dijit._Widget, dijit._Templated], {
	
	messages: messages,
	widgetsInTemplate: true,
	templateString:
				'<div class="item" style="overflow: auto;">' +
					'<div dojoAttachPoint="treeNav">' +
				'</div>' +
			'</div>',
	
	// init properties
	editor: null,
	
	resize: function(size) {
		if (size && size.h) {
			dojo.marginBox(this.domNode, {h: size.h});
		}
	},
	
	postCreate: function() {
		var ia = this.editor.editorInput.impactAnalysis;

		//when control clicking certain areas, it highlights all the 'cells' in the editor container (aka the 'content-cell')
		//dojo.addClass(dojo.byId('content-cell'), 'disable-table-highlighting');
		dojo.addClass(this.domNode, 'disable-table-highlighting');

		//don't allow a browser right click menu anywhere near the navigation tree, let the tree itself override this in
		//specific circumstances (e.g. context menu for a right-clicked artifact in the tree)
		this.connect(this.domNode, "oncontextmenu", function(e) { dojo.stopEvent(e); } );
	},
		
	reset: function(info){
	},
	
	getTreeNav : function ()
	{
		return this.treeNav;
	}
	
	
});
})();