/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function () {
	dojo.provide("dm.analysis.app.ui.internal.impactanalysis.picker.LocateElementControler");
	
	dojo.require('dm.analysis.app.ui.picker');
	dojo.require("dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil");
	
	var AnalysisUtil = dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil;
	dojo.declare("dm.analysis.app.ui.internal.impactanalysis.picker.LocateElementControler", null,  {

		locateElement: function (caller) {
			// summary:
			//		Open a host-supplied picker to locate a host resource
			
			dm.analysis.app.ui.picker.showPicker(function (resourceUri) {
				//TODO: Refactor code to be cleaner and more robust
				if (resourceUri) {
					contextConfigVersionUri = null;
					if (!AnalysisUtil.isConfigVersion(resourceUri)){
						if (caller.newContextConfigVersionUri)
						{
							contextConfigVersionUri = caller.newContextConfigVersionUri;
						}
						else if (caller.editor && caller.editor.editorInput.impactAnalysis.contextConfigVersionUri) //coming from AddElementListPanel
						{
							contextConfigVersionUri = caller.editor.editorInput.impactAnalysis.contextConfigVersionUri;
						} 
						else if (caller.editorInput && caller.editorInput.impactAnalysis.contextConfigVersionUri) {
							contextConfigVersionUri = caller.editorInput.impactAnalysis.contextConfigVersionUri
						}
					}
					caller.updateAfterLocate(resourceUri, contextConfigVersionUri);
				}
			});
		}
	});

}());