/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function () {
	dojo.provide('dm.analysis.app.ui.internal.impactanalysis.util.ResourceLinkUtil');

	dojo.require("jazz.ui.ResourceLink");

	dojo.require("dm.analysis.app.ui.DiagramUtilityMethods");

	var DiagramUtilityMethods = dm.analysis.app.ui.DiagramUtilityMethods;

	dojo.mixin(dm.analysis.app.ui.internal.impactanalysis.util.ResourceLinkUtil, {
		createResourceLink: function (parentDomNode, resourceLinkCreateArgs) {
			// summary
			//		Create a jazz.ui.ResourceLink that is set up with IA's presentation hooks

			// Compute the rendering and presentation URI's to open the resource
			var renderingUri = DiagramUtilityMethods.call_getCompactRenderingUri(resourceLinkCreateArgs.uri),
				presentationUri = DiagramUtilityMethods.call_getResourceEditUri(resourceLinkCreateArgs.uri) || renderingUri,
				resourceLink,
				imageNode;

			// replace the passed uri with the calculated rendering uri
			resourceLinkCreateArgs.uri = renderingUri;
			resourceLinkCreateArgs.presentationUri = presentationUri;
			resourceLinkCreateArgs.iconNode = parentDomNode.appendChild(dojo.create("span"));

			// Add defaults to create args passed..
			resourceLinkCreateArgs = dojo.mixin({
				lazyFetch : false
			}, resourceLinkCreateArgs);
			
			// Create the resource link
			resourceLink = new jazz.ui.ResourceLink(resourceLinkCreateArgs);

			parentDomNode.appendChild(resourceLink.domNode);
			resourceLink.startup();

			return resourceLink;
		}
	});
}());