/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.common.app.ui.internal.rhlink.AnalysisConfigClient");

dojo.require("dojox.xml.DomParser");

dojo.require("jazz.app.context");
dojo.require("jazz.client.xhr");
dojo.require("rmps.core.client");

dm.common.app.ui.internal.rhlink.AnalysisConfigClient = {

	getToolsTypes: function(projectID , remoteServer) {
		var queryParams = {			
			"projectID": projectID ,
			"remoteserver":remoteServer
		};
		var args = {
			url: net.jazz.ajax._contextRoot + "/getalltools?" + dojo.objectToQuery(queryParams),
			handleAs: "json",
			headers: {},
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return rmps.core.client.xhrGet(args, false);
	},
	
	getTypesForTool: function(projectID, toolType , forLinks) {
		var queryParams = {			
			"projectID": projectID,
			"toolType": toolType,
			"forLinks": forLinks
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			url: net.jazz.ajax._contextRoot + "/typesfortool?" + dojo.objectToQuery(queryParams),
			handleAs: "json",
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				console.error(response);
			}
		};
		return rmps.core.client.xhrGet(args);
	}

};

})();