/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.common.app.ui.internal.rhlink.LocateClient");

dojo.require("dojox.xml.DomParser");

dojo.require("jazz.app.context");
dojo.require("jazz.client.xhr");

dm.common.app.ui.internal.rhlink.LocateClient = {
	
	getLocatedElements: function(filters, pattern ,projectId ) {
		
		projectId = jazz.app.context.get().itemId;
		var queryParams = {
			"projectId": projectId ,
			"pattern" : pattern
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true",
				"Content-Type": "application/xml",
				"Accept": "application/json"
			},
			url: net.jazz.ajax._contextRoot + "/analysislocate?"
				+ dojo.objectToQuery(queryParams),
			handleAs: "json",
			hasBody: true,
			postData: filters ? filters : null
		};
		return jazz.client.xhrPost(args);
	},
	
	getAllFilterDescriptors: function(projectId ) {
		
		projectId = jazz.app.context.get().itemId;
		var queryParams = {
			"projectId": projectId 
			
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true",
				"Content-Type": "application/xml",
				"Accept": "application/json"
			},
			url: net.jazz.ajax._contextRoot + "/analysislocate?"
				+ dojo.objectToQuery(queryParams),
			handleAs: "json",
			hasBody: true
		};
		return jazz.client.xhrGet(args);
	},
	
	getDynamicListForFilter: function(projectId , filterID , filters ) {
		
		projectId = jazz.app.context.get().itemId;
		var queryParams = {
			"projectId": projectId ,
			"filterID" : filterID
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
	
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true",
				"Content-Type": "application/rdf+xml",
				"Accept": "application/atom+json"
			},
			url: net.jazz.ajax._contextRoot + "/analysislocate?"
				+ dojo.objectToQuery(queryParams),
			handleAs: "json",
			hasBody: true,
			postData: filters ? filters : null
		};
		return jazz.client.xhrPost(args);
	}

};

})();