/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.common.app.ui.internal.rhlink.LocateElementDialog");
dojo.require("jazz.ui.Dialog");
dojo.require("dm.common.app.ui.internal.rhlink.LocateClient");
dojo.require("jazz.app.context");
dojo.require("jazz.ui.StyledBox");

var thispage;
dojo.declare("dm.common.app.ui.internal.rhlink.LocateElementDialog", null,  {
	resourceInfo: null,
	text: null,
	width: null,
	projectId: null,
	parent: null,
	locateSourceButton: null,
	selectRelationTarget: null,
	createTable: null,
	searchCriteria: null,
	
	constructor: function(parent) {
		thispage = this;
		this.parent = parent;
		this.projectId = jazz.app.context.get().itemId;
		this.createDialog(this.text,this.width);
	},
		
	createDialog: function(text, width){
		
		var createTable = dojo.doc.createElement("table");
	
		this.createSearchButton = dojo.doc.createElement("button");
		this.createSearchButton.innerHTML = "Search";
		this.inprogress(true);
		
		
		this.searchCriteria = dojo.doc.createElement("input");
		
		dojo.connect(this.createSearchButton,"onclick", function() { thispage.searchTarget(); } );
		this.createRelationRowSearch(createTable,"Search Text:" , this.searchCriteria, this.createSearchButton);
		this.searchResult =  dojo.doc.createElement("span");
		this.searchResult.innerHTML = "No Results !";
		this.searchResult.style.visibility="hidden";
		this.selectRelationTarget = dojo.doc.createElement("select");
	    this.createRelationRowSearch(createTable,"Target Element Name:" , this.selectRelationTarget , this.searchResult);
		
		this.locateSourceButton = dojo.doc.createElement("button");
		this.locateSourceButton.innerHTML = "Locate Element";
		dojo.connect(this.locateSourceButton,"onclick", function() { thispage.close(); });
		this.createRelationRow(createTable,null , this.locateSourceButton);
		
		var dialogContent = dojo.doc.createElement("div");
		dialogContent.className =  "rh-app-pages-rh-links";
		dialogContent.appendChild(createTable);
		
		this.createDialog = new jazz.ui.Dialog({
			//primaryTitle: "Create Inter-Link: " + this.parent.resourceName,
			primaryTitle: "Locate Element ",
			modal: true,
			trim: jazz.ui.StyledBox.TrimStyles.BLUE_ALPHA_SHADOW,
			center: true,
			closeOnEsc: true,
			headerless: false,
			closable: true,
			width: 700 + "px",
			moveable: true,
			collapsible: false,
			showBackground: false,
			contentNode: dialogContent,
			onClose: parent.closeEdit
		});
	},
	
	inprogress: function (ingrogress)
	{
		/*if (ingrogress == true)
		{
			this.createSearchButton.disabled =true
		}
		else
		{
			this.createSearchButton.disabled =false
		}*/
	}
	,
	
	createRelationRow: function(table ,name , value)
	{
		var tr = dojo.doc.createElement("tr");
		if (name)
		{
			var td1 = dojo.doc.createElement("td");
			td1.innerHTML = name;
			tr.appendChild(td1);
		}
		var td2 = dojo.doc.createElement("td");
		td2.appendChild(value);
		tr.appendChild(td2);
		table.appendChild(tr);
	},
	
	createRelationRowSearch: function(table ,name , value1, value2)
	{
		var tr = dojo.doc.createElement("tr");
		if (name)
		{
			var td1 = dojo.doc.createElement("td");
			td1.innerHTML = name;
			tr.appendChild(td1);
		}
		var td2 = dojo.doc.createElement("td");
		td2.appendChild(value1);
		tr.appendChild(td2);
		var td3 = dojo.doc.createElement("td");
		td3.appendChild(value2);
		tr.appendChild(td3);
		table.appendChild(tr);
	},
	
	close: function() {
		thispage.parent.updateAfterLocate(thispage.selectRelationTarget.value , true);
		thispage.createDialog.close();
		
    },
	
    
	
	buildFilters :function()
	{
		var retval =  "<dmlocate:filters xmlns:dmlocate=\"http://jazz.net/xmlns/dm/locate/1.0/\">"+
					"<dmlocate:filter>"+
						"<dmlocate:uri>myfilterURI</dmlocate:uri>"+
						"<dmlocate:value>a,b,c</dmlocate:value>"+
						"<dmlocate:multivalue>true</dmlocate:multivalue>"+
					"</dmlocate:filter>"+
				"</dmlocate:filters>";
		return retval;
		
	},
	
	searchTarget: function()
	{
		while(this.selectRelationTarget.hasChildNodes()){
				this.selectRelationTarget.removeChild(this.selectRelationTarget.lastChild);
		}
		this.searchResult.style.visibility="hidden";
		var getLocatedElements;
		this.inprogress(true);
			
		var filters = this.buildFilters();
		getLocatedElements = dm.common.app.ui.internal.rhlink.LocateClient.getLocatedElements(filters,
																							thispage.searchCriteria.value,																							
																							thispage.projectId
																							);
		getLocatedElements.addCallback(this, this.loadLocatedElementes);
	},
	//?resUri ?name ?rdfType ?rdfTitle 
	loadLocatedElementes: function(loadData) {
		var targetsData = eval(loadData).locateResults;
		if (targetsData) {
			if (targetsData.length !== 0)
			{
				this.searchResult.style.visibility="hidden";
			}
			else
			{
				this.searchResult.style.visibility="visible";
			}
			for(var i = 0 ; i < targetsData.length ; i++) {
				var optionChild = dojo.doc.createElement("option");
				var type = targetsData[i].type;
				var split = type.split("/");
				type = split[split.length-1];
				if (type.indexOf("#") > 0)
				{
					split = type.split("#");
					type = split[split.length-1];
				}
				optionChild.innerHTML = type + "," + targetsData[i].name;
				optionChild.value=targetsData[i].URI;
				thispage.selectRelationTarget.appendChild(optionChild);
			}
		}
		this.inprogress(false);
	}
	
	
});

})();