/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.common.app.ui.internal.rhlink.LocateRHSourceDialog");
dojo.require("jazz.ui.Dialog");
dojo.require("dm.common.app.ui.internal.rhlink.RHLinkClient");
dojo.require("jazz.app.context");
dojo.require("jazz.ui.StyledBox");

var thispage;
dojo.declare("dm.common.app.ui.internal.rhlink.LocateRHSourceDialog", null,  {
	resourceInfo: null,
	text: null,
	width: null,
	projectId: null,
	parent: null,
	selectRelationType: null,
	locateSourceButton: null,
	relationDesc: null,
	selectRelationTarget: null,
	selectTargetType: null,
	createTable: null,
	resourceUri: null,
	direction: null,
	searchCriteria: null,
	
	constructor: function(parent , resourceUri) {
		thispage = this;
		this.resourceUri = resourceUri;
		this.parent = parent;
		this.projectId = jazz.app.context.get().itemId;
		this.createDialog(this.text,this.width);
	},
		
		createDialog: function(text, width){
		
		var createTable = dojo.doc.createElement("table");
		//TBD put real content and functionality here
		this.toolType = dojo.doc.createElement("select");
		this.createSearchButton = dojo.doc.createElement("button");
		this.createSearchButton.innerHTML = "Search";
		this.inprogress(true);
		this.createRelationRow(createTable,"Tool:" , this.toolType);
		this._getToolsTypesDeferred = dm.common.app.ui.internal.rhlink.RHLinkClient.getToolsTypes(this.projectId);
		this._getToolsTypesDeferred.addCallback(this, function(tools) {
			this.toolType.appendChild(dojo.doc.createElement("option"));
			for(var i = 0 ; i < tools.tools.length ; i++) {
				var optionChild = dojo.doc.createElement("option");
				optionChild.innerHTML = tools.tools[i].ToolType;
				optionChild.value=tools.tools[i].ToolURI;
				this.toolType.appendChild(optionChild);
			}
			this.inprogress(false);
			
		});
		
		dojo.connect(this.toolType,"onchange", function() { 
			thispage.loadSelectLD(); 
		});
		
		this.selectLD = dojo.doc.createElement("select");
		this.createRelationRow(createTable,"Target Element Type:" , this.selectLD);
		
		this.searchCriteria = dojo.doc.createElement("input");
		
		dojo.connect(this.createSearchButton,"onclick", function() { thispage.searchTarget(); } );
		this.createRelationRowSearch(createTable,"Search Text:" , this.searchCriteria, this.createSearchButton);
		this.searchResult =  dojo.doc.createElement("span");
		this.searchResult.innerHTML = "No Results !";
		this.searchResult.style.visibility="hidden";
		this.selectRelationTarget = dojo.doc.createElement("select");
		this.createRelationRowSearch(createTable,"Target Element Name:" , this.selectRelationTarget , this.searchResult);
		
		this.locateSourceButton = dojo.doc.createElement("button");
		this.locateSourceButton.innerHTML = "Locate Element";
		dojo.connect(this.locateSourceButton,"onclick", function() { thispage.locate(); });
		this.createRelationRow(createTable,null , this.locateSourceButton);
		
		var dialogContent = dojo.doc.createElement("div");
		dialogContent.className =  "rh-app-pages-rh-links";
		dialogContent.appendChild(createTable);
		
		this.createDialog = new jazz.ui.Dialog({
			//primaryTitle: "Create Inter-Link: " + this.parent.resourceName,
			primaryTitle: "Locate Element in RH",
			modal: true,
			trim: jazz.ui.StyledBox.TrimStyles.BLUE_ALPHA_SHADOW,
			center: true,
			closeOnEsc: true,
			headerless: false,
			closable: true,
			width: 700 + "px",
			moveable: true,
			collapsible: false,
			showBackground: false,
			contentNode: dialogContent,
			onClose: parent.closeEdit
		});
	},
	
	inprogress: function (ingrogress)
	{
		if (ingrogress === true)
		{
			this.createSearchButton.disabled =true;
		}
		else
		{
			this.createSearchButton.disabled =false;
		}
	}
	,
	
	createRelationRow: function(table ,name , value)
	{
		var tr = dojo.doc.createElement("tr");
		if (name)
		{
			var td1 = dojo.doc.createElement("td");
			td1.innerHTML = name;
			tr.appendChild(td1);
		}
		var td2 = dojo.doc.createElement("td");
		td2.appendChild(value);
		tr.appendChild(td2);
		table.appendChild(tr);
	},
	
	createRelationRowSearch: function(table ,name , value1, value2)
	{
		var tr = dojo.doc.createElement("tr");
		if (name)
		{
			var td1 = dojo.doc.createElement("td");
			td1.innerHTML = name;
			tr.appendChild(td1);
		}
		var td2 = dojo.doc.createElement("td");
		td2.appendChild(value1);
		tr.appendChild(td2);
		var td3 = dojo.doc.createElement("td");
		td3.appendChild(value2);
		tr.appendChild(td3);
		table.appendChild(tr);
	},
	
	locate: function() {
		thispage.parent.updateAfterLocate(thispage.selectRelationTarget.value , true);
		thispage.createDialog.close();
		
    },
	
    loadSelectLD: function()
	{
		while(this.selectLD.hasChildNodes()){
			this.selectLD.removeChild(this.selectLD.lastChild);
		}
		if (this.toolType.value !== "") 
		{
			this.inprogress(true);
			var getTargetLDDeferred = dm.common.app.ui.internal.rhlink.RHLinkClient.getLeadingDimensionFor(this.toolType.value);
			getTargetLDDeferred.addCallback(this, this.loadLD);
		}
	},
	
	loadTargets: function(loadData) {
		var targetsData = eval(loadData);
		if (targetsData) {
			thispage.selectRelationTarget.appendChild(dojo.doc.createElement("option"));
			for(var i = 0 ; i < targetsData.target.length ; i++) {
				var optionChild = dojo.doc.createElement("option");
				var type = targetsData.target[i].fullType;
				var split = type.split("/");
				type = split[split.length-1];
				if (type.indexOf("#") > 0)
				{
					split = type.split("#");
					type = split[split.length-1];
				}
				optionChild.innerHTML = type + "," + targetsData.target[i].shortName;
				optionChild.value=targetsData.target[i].uri;
				thispage.selectRelationTarget.appendChild(optionChild);
			}
		}
	},
	
	loadLD: function(loadData) {
		thispage.currentLDs = eval(loadData).info;
		if (thispage.currentLDs) {
			thispage.selectRelationTarget.appendChild(dojo.doc.createElement("option"));
			var optionChild = dojo.doc.createElement("option");
			thispage.selectLD.appendChild(optionChild);
			for(var i = 0 ; i < thispage.currentLDs.length ; i++) {
				optionChild = dojo.doc.createElement("option");
				var html = thispage.currentLDs[i].rdfTitle;
				if (thispage.currentLDs[i].LDTitle !== "")
				{
					html  = html + "> " + thispage.currentLDs[i].LDTitle  + " : " + thispage.currentLDs[i].LD ;
				}
				optionChild.innerHTML =  html;
				optionChild.value=i;
				thispage.selectLD.appendChild(optionChild);
			}
		}
		this.inprogress(false);
	},
	searchTarget: function()
	{
		while(this.selectRelationTarget.hasChildNodes()){
				this.selectRelationTarget.removeChild(this.selectRelationTarget.lastChild);
		}
		this.searchResult.style.visibility="hidden";
		var index = thispage.selectLD.value;
		//?appUri ?LDUri ?LD ?rdfType ?projectID ?search 
		var getTargetLDDeferred;
		this.inprogress(true);
		if (index !== "")
		{
			getTargetLDDeferred = dm.common.app.ui.internal.rhlink.RHLinkClient.getLocatedElements(thispage.toolType.value ,
																							thispage.currentLDs[index].LDUri,
																							thispage.currentLDs[index].LD,
																							thispage.currentLDs[index].LDValueASURI,
																							thispage.currentLDs[index].rdfType,																							
																							thispage.projectId,
		                                                                                    thispage.searchCriteria.value 
																							);
		}
		else
		{
			getTargetLDDeferred = dm.common.app.ui.internal.rhlink.RHLinkClient.getLocatedElements(thispage.toolType.value ,
																							"",
																							"",
																							"",
																							"",
																							thispage.projectId,
		                                                                                    thispage.searchCriteria.value 
																							);
		}
		getTargetLDDeferred.addCallback(this, this.loadTargets1);
	},
	//?resUri ?name ?rdfType ?rdfTitle 
	loadTargets1: function(loadData) {
		var targetsData = eval(loadData).info;
		if (targetsData) {
			//thispage.selectRelationTarget.appendChild(dojo.doc.createElement("option"));
			if (targetsData.length !== 0)
			{
				this.searchResult.style.visibility="hidden";
			}
			else
			{
				this.searchResult.style.visibility="visible";
			}
			for(var i = 0 ; i < targetsData.length ; i++) {
				var optionChild = dojo.doc.createElement("option");
				var type = targetsData[i].rdfTitle;
				optionChild.innerHTML = targetsData[i].rdfTitle + "," + targetsData[i].name;
				optionChild.value=targetsData[i].resUri;
				thispage.selectRelationTarget.appendChild(optionChild);
			}
		}
		this.inprogress(false);
	}
	
	
});

})();