/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.common.app.ui.internal.rhlink.RHLinkClient");

dojo.require("dojox.xml.DomParser");

dojo.require("jazz.app.context");
dojo.require("jazz.client.xhr");

dm.common.app.ui.internal.rhlink.RHLinkClient = {
	
	getTargetsFor: function(resourceUri, projectID) {
		
		var queryParams = {
			"source": resourceUri ,
			"projectID": projectID
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			url: net.jazz.ajax._contextRoot + "/targets?"
				+ dojo.objectToQuery(queryParams),
			handleAs: "json",
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				alert(response);
			}
		};
		return jazz.client.xhrGet(args);
	},
	
	getLinksFor: function(resourceUri) {
		
		var queryParams = {
			"source": resourceUri
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			url: net.jazz.ajax._contextRoot + "/rhlinks?"
				+ dojo.objectToQuery(queryParams),
			handleAs: "json",
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				alert(response);
			}
		};
		return jazz.client.xhrGet(args);
	},
	
	getRemoteServers: function()
	{
		var queryParams = {
			"request": "getservers"
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			url: net.jazz.ajax._contextRoot + "/distcenter?"
				+ dojo.objectToQuery(queryParams),
			handleAs: "json",
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				alert(response);
			}
		};
		return jazz.client.xhrGet(args);
	},
    
	getToolsTypes: function(projectID , remoteServer) {
		
		var queryParams = {			
			"projectID": projectID ,
			"remoteserver":remoteServer
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			url: net.jazz.ajax._contextRoot + "/rhlocator/existingtools?"
				+ dojo.objectToQuery(queryParams),
			handleAs: "json",
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				alert(response);
			}
		};
		return jazz.client.xhrGet(args);
	},
	
	getLeadingDimensionFor: function(appUri , remoteServer)
	{
		var queryParams = {
			"appUri": appUri ,
			"remoteserver":remoteServer
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			url: net.jazz.ajax._contextRoot + "/rhlocator/ld?" 
				+ dojo.objectToQuery(queryParams),
			handleAs: "json",
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				alert(response);
			}
		};
		return jazz.client.xhrGet(args);
	},
	
	getInterLinkTypes: function(projectID) {
		var queryParams = {			
			"projectID": projectID
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			url: net.jazz.ajax._contextRoot + "/rhlocator/intertypes?"
				+ dojo.objectToQuery(queryParams),
			handleAs: "json",
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				alert(response);
			}
		};
		return jazz.client.xhrGet(args);
	},
	//?appUri ?LDUri ?LD ?rdfType ?projectID ?search 
	getLocatedElements: function(appUri, LDUri, LD , LDValueASURI, rdfType,projectID,search ,remoteServer) {
		var links = [];
		
		var queryParams = {		
			"appUri" : appUri,	
			"LDUri" : LDUri,
			"LD": LD,
			"LDValueASURI":LDValueASURI,
			"rdfType" : rdfType,
			//"projectID" : projectID,
			"searchQuery": search,
			"remoteserver":remoteServer
			
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			url: net.jazz.ajax._contextRoot + "/rhlocator/locate?"
				+ dojo.objectToQuery(queryParams),
			handleAs: "json",
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				alert(response);
			}
		};
		return jazz.client.xhrGet(args);
	},
	 
	handleElement: function(resourceUri ,resourceName , resourceType , toolName , pageUri  ,projectId) {
		var queryParams = {		
			"resourceUri" : resourceUri,	
			"resourceName" : resourceName,
			"resourceType": resourceType,
			"toolName" : toolName,
			"pageUri" : pageUri,
			"projectId" : projectId
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			url: net.jazz.ajax._contextRoot + "/rhlocator/hdlelement?"
				+ dojo.objectToQuery(queryParams),
			handleAs: "json",
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				alert(response);
			}
		};
		return jazz.client.xhrGet(args);
	},
	
	// ============================ VALIDATOR ===================================
	getBaselines: function(projectID, simulate, useJazz) {
		var queryParams = {			
			"projectID": projectID,
			"simulate": simulate,
			"jazz": useJazz
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			url: net.jazz.ajax._contextRoot + "/rhlocator/existingbaselines?"
				+ dojo.objectToQuery(queryParams),
			handleAs: "json",
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				alert(response);
			}
		};
		return jazz.client.xhrGet(args);
	},
	getProductNodesInfo: function(product_URI, product_NAME, base_line_URI, projectID, simulate, useJazz) {

		var queryParams = {			
			"projectID": projectID,
			"product_URI": product_URI,
			"product_NAME": product_NAME,
			"base_line_URI": base_line_URI,
			"simulate": simulate,
			"jazz": useJazz
		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			url: net.jazz.ajax._contextRoot + "/rhlocator/productnodesinfo?"
				+ dojo.objectToQuery(queryParams),
			handleAs: "json",
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				alert(response);
			}
		};
		return jazz.client.xhrGet(args);
	},

	validateProduct: function(product_URI, product_NAME, base_line_URI, projectID, simulate, useJazz) {

		var queryParams = {			
			"projectID": projectID,
			"product_URI": product_URI,
			"product_NAME": product_NAME,
			"base_line_URI": base_line_URI,
			"simulate": simulate,
			"jazz": useJazz

		};
		if(jazz.app.context.get().baseline) {
			// add in DM context, if found in Jazz app context.
			queryParams["rmps.context"] = jazz.app.context.get().baseline;
		}
		var args = {
			url: net.jazz.ajax._contextRoot + "/rhlocator/validate?"
				+ dojo.objectToQuery(queryParams),
			handleAs: "json",
			timeout: 99999999,
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				alert(response);
			}
		};
		return jazz.client.xhrGet(args);
	},

	getProducts: function(projectID, simulate) {
		
		var queryParams = {			
			"projectID": projectID,
			"simulate": simulate
		};
		var args = {
			url: net.jazz.ajax._contextRoot + "/rhlocator/existingsystems?"
				+ dojo.objectToQuery(queryParams),
			handleAs: "json",
			headers: { "X-ibm-rmps-internal": "true" },
			load: function(response, ioArgs)
			{
				return response;
			},
			error: function(response, ioArgs) {
				alert(response);
			}
		};
		return jazz.client.xhrGet(args);
	}
};

})();